Entry
Elementary

## Data Structures

struct | _Elm_Entry_Anchor_Info
| The info sent in the callback for the "anchor,clicked" signals emitted by entries. More...
struct | _Elm_Entry_Anchor_Hover_Info
| The info sent in the callback for "anchor,clicked" signals emitted by the Anchor_Hover widget. More...
struct | _Elm_Entry_Filter_Limit_Size
| Data for the elm_entry_filter_limit_size() entry filter. More...
struct | _Elm_Entry_Filter_Accept_Set
| Data for the elm_entry_filter_accept_set() entry filter. More...

## Macros

#define | ELM_ENTRY_CLASS elm_entry_class_get()
| Elementary entry class.
#define | ELM_ENTRY_EVENT_ACTIVATED (&(_ELM_ENTRY_EVENT_ACTIVATED))
| Called when entry got activated.
#define | ELM_ENTRY_EVENT_CHANGED (&(_ELM_ENTRY_EVENT_CHANGED))
| Called when entry changed.
#define | ELM_ENTRY_EVENT_CHANGED_USER (&(_ELM_ENTRY_EVENT_CHANGED_USER))
| Called when the object changed due to user interaction.
#define | ELM_ENTRY_EVENT_VALIDATE (&(_ELM_ENTRY_EVENT_VALIDATE))
| Called when validating.
#define | ELM_ENTRY_EVENT_CONTEXT_OPEN (&(_ELM_ENTRY_EVENT_CONTEXT_OPEN))
| Called when context menu was opened.
#define | ELM_ENTRY_EVENT_ANCHOR_CLICKED (&(_ELM_ENTRY_EVENT_ANCHOR_CLICKED))
| Called when anchor was clicked.
#define | ELM_ENTRY_EVENT_REJECTED (&(_ELM_ENTRY_EVENT_REJECTED))
| Called when entry was rejected.
#define | ELM_ENTRY_EVENT_MAXLENGTH_REACHED (&(_ELM_ENTRY_EVENT_MAXLENGTH_REACHED))
| Called when maximum entry length has been reached.
#define | ELM_ENTRY_EVENT_PREEDIT_CHANGED (&(_ELM_ENTRY_EVENT_PREEDIT_CHANGED))
| Called when entry preedit changed.
#define | ELM_ENTRY_EVENT_PRESS (&(_ELM_ENTRY_EVENT_PRESS))
| Called when entry pressed.
#define | ELM_ENTRY_EVENT_REDO_REQUEST (&(_ELM_ENTRY_EVENT_REDO_REQUEST))
| Called when redo was requested.
#define | ELM_ENTRY_EVENT_UNDO_REQUEST (&(_ELM_ENTRY_EVENT_UNDO_REQUEST))
| Called when undo was requested.
#define | ELM_ENTRY_EVENT_TEXT_SET_DONE (&(_ELM_ENTRY_EVENT_TEXT_SET_DONE))
| Called when text set finished.
#define | ELM_ENTRY_EVENT_ABORTED (&(_ELM_ENTRY_EVENT_ABORTED))
| Called when entry was aborted.
#define | ELM_ENTRY_EVENT_ANCHOR_DOWN (&(_ELM_ENTRY_EVENT_ANCHOR_DOWN))
| Called on anchor down.
#define | ELM_ENTRY_EVENT_ANCHOR_HOVER_OPENED (&(_ELM_ENTRY_EVENT_ANCHOR_HOVER_OPENED))
| Called when hover opened.
#define | ELM_ENTRY_EVENT_ANCHOR_IN (&(_ELM_ENTRY_EVENT_ANCHOR_IN))
| Called on anchor in.
#define | ELM_ENTRY_EVENT_ANCHOR_OUT (&(_ELM_ENTRY_EVENT_ANCHOR_OUT))
| Called on anchor out.
#define | ELM_ENTRY_EVENT_ANCHOR_UP (&(_ELM_ENTRY_EVENT_ANCHOR_UP))
| called on anchor up
#define | ELM_ENTRY_EVENT_CURSOR_CHANGED (&(_ELM_ENTRY_EVENT_CURSOR_CHANGED))
| Called on cursor changed.
#define | ELM_ENTRY_EVENT_CURSOR_CHANGED_MANUAL (&(_ELM_ENTRY_EVENT_CURSOR_CHANGED_MANUAL))
| Called on manual cursor change.

## Typedefs

typedef struct _Elm_Entry_Anchor_Info | Elm_Entry_Anchor_Info
| The info sent in the callback for the "anchor,clicked" signals emitted by entries.
typedef struct _Elm_Entry_Anchor_Hover_Info | Elm_Entry_Anchor_Hover_Info
| The info sent in the callback for "anchor,clicked" signals emitted by the Anchor_Hover widget.
typedef struct _Elm_Entry_Context_Menu_Item | Elm_Entry_Context_Menu_Item
| Type of contextual item that can be added in to long press menu.
typedef Evas_Object *(* | Elm_Entry_Item_Provider_Cb) (void *data, Evas_Object *entry, const char *item)
| This callback type is used to provide items.
typedef void(* | Elm_Entry_Filter_Cb) (void *data, Evas_Object *entry, char **text)
| This callback type is used by entry filters to modify text.
typedef Edje_Entry_Change_Info | Elm_Entry_Change_Info
| This corresponds to Edje_Entry_Change_Info.
typedef struct _Elm_Entry_Filter_Limit_Size | Elm_Entry_Filter_Limit_Size
| Data for the elm_entry_filter_limit_size() entry filter.
typedef struct _Elm_Entry_Filter_Accept_Set | Elm_Entry_Filter_Accept_Set
| Data for the elm_entry_filter_accept_set() entry filter.

## Enumerations

enum | Elm_Input_Panel_Layout_Normal_Variation { ELM_INPUT_PANEL_LAYOUT_NORMAL_VARIATION_NORMAL , ELM_INPUT_PANEL_LAYOUT_NORMAL_VARIATION_FILENAME , ELM_INPUT_PANEL_LAYOUT_NORMAL_VARIATION_PERSON_NAME }
| Enumeration for defining the types of Elm Input Panel Layout for normal variation. More...
enum | Elm_Input_Panel_Layout_Numberonly_Variation { ELM_INPUT_PANEL_LAYOUT_NUMBERONLY_VARIATION_NORMAL , ELM_INPUT_PANEL_LAYOUT_NUMBERONLY_VARIATION_SIGNED , ELM_INPUT_PANEL_LAYOUT_NUMBERONLY_VARIATION_DECIMAL , ELM_INPUT_PANEL_LAYOUT_NUMBERONLY_VARIATION_SIGNED_AND_DECIMAL }
| Enumeration for defining the types of Elm Input Panel Layout for number only variation. More...
enum | Elm_Input_Panel_Layout_Password_Variation { ELM_INPUT_PANEL_LAYOUT_PASSWORD_VARIATION_NORMAL , ELM_INPUT_PANEL_LAYOUT_PASSWORD_VARIATION_NUMBERONLY }
| Enumeration for defining the types of Elm Input Panel Layout for password variation. More...

## Functions

Eina_Bool | elm_config_context_menu_disabled_get (void)
| Get enable status of context menu disabled.
void | elm_config_context_menu_disabled_set (Eina_Bool disabled)
| Enable or disable the context menu in entries.
EINA_DEPRECATED void | elm_scrolled_entry_cnp_textonly_set (Evas_Object *obj, Eina_Bool textonly)
| This function sets the entry to textonly mode.
EINA_DEPRECATED Eina_Bool | elm_scrolled_entry_cnp_textonly_get (Evas_Object *obj)
| This function gets the current textonly mode of the entry.
EINA_DEPRECATED void | elm_entry_scrollbar_policy_set (Evas_Object *obj, Elm_Scroller_Policy h, Elm_Scroller_Policy v)
| This sets the entry's scrollbar policy (i.e.
EINA_DEPRECATED void | elm_entry_bounce_set (Evas_Object *obj, Eina_Bool h_bounce, Eina_Bool v_bounce)
| This enables/disables bouncing within the entry.
EINA_DEPRECATED void | elm_entry_bounce_get (const Evas_Object *obj, Eina_Bool *h_bounce, Eina_Bool *v_bounce)
| Get the bounce mode.
char * | elm_entry_markup_to_utf8 (const char *s)
| This converts a markup (HTML-like) string into UTF-8.
char * | elm_entry_utf8_to_markup (const char *s)
| This converts a UTF-8 string into markup (HTML-like).
void | elm_entry_filter_limit_size (void *data, Evas_Object *entry, char **text)
| Filter inserted text based on user defined character and byte limits.
void | elm_entry_filter_accept_set (void *data, Evas_Object *entry, char **text)
| Filter inserted text based on accepted or rejected sets of characters.
const char * | elm_entry_context_menu_item_label_get (const Elm_Entry_Context_Menu_Item *item)
| Get the text of the contextual menu item of entry.
void | elm_entry_context_menu_item_icon_get (const Elm_Entry_Context_Menu_Item *item, const char **icon_file, const char **icon_group, Elm_Icon_Type *icon_type)
| Get the icon object packed in the contextual menu item of entry.
EOAPI void | elm_obj_entry_scrollable_set (Eo *obj, Eina_Bool scroll)
| Enable or disable scrolling in entry.
EOAPI Eina_Bool | elm_obj_entry_scrollable_get (const Eo *obj)
| Get the scrollable state of the entry.
EOAPI void | elm_obj_entry_input_panel_show_on_demand_set (Eo *obj, Eina_Bool ondemand)
| Set the attribute to show the input panel in case of only a user's explicit Mouse Up event.
EOAPI Eina_Bool | elm_obj_entry_input_panel_show_on_demand_get (const Eo *obj)
| Get the attribute to show the input panel in case of only a user's explicit Mouse Up event.
EOAPI void | elm_obj_entry_context_menu_disabled_set (Eo *obj, Eina_Bool disabled)
| This disables the entry's contextual (longpress) menu.
EOAPI Eina_Bool | elm_obj_entry_context_menu_disabled_get (const Eo *obj)
| This returns whether the entry's contextual (longpress) menu is disabled.
EOAPI void | elm_obj_entry_cnp_mode_set (Eo *obj, Elm_Cnp_Mode cnp_mode)
| Control pasting of text and images for the widget.
EOAPI Elm_Cnp_Mode | elm_obj_entry_cnp_mode_get (const Eo *obj)
| Getting elm_entry text paste/drop mode.
EOAPI void | elm_obj_entry_file_text_format_set (Eo *obj, Elm_Text_Format format)
| Text format used to load and save the file, which could be plain text or markup text.
EOAPI void | elm_obj_entry_input_panel_language_set (Eo *obj, Elm_Input_Panel_Lang lang)
| Set the language mode of the input panel.
EOAPI Elm_Input_Panel_Lang | elm_obj_entry_input_panel_language_get (const Eo *obj)
| Get the language mode of the input panel.
EOAPI void | elm_obj_entry_selection_handler_disabled_set (Eo *obj, Eina_Bool disabled)
| This disabled the entry's selection handlers.
EOAPI Eina_Bool | elm_obj_entry_selection_handler_disabled_get (const Eo *obj)
| This returns whether the entry's selection handlers are disabled.
EOAPI void | elm_obj_entry_input_panel_layout_variation_set (Eo *obj, int variation)
| Set the input panel layout variation of the entry.
EOAPI int | elm_obj_entry_input_panel_layout_variation_get (const Eo *obj)
| Get the input panel layout variation of the entry.
EOAPI void | elm_obj_entry_autocapital_type_set (Eo *obj, Elm_Autocapital_Type autocapital_type)
| Set the autocapitalization type on the immodule.
EOAPI Elm_Autocapital_Type | elm_obj_entry_autocapital_type_get (const Eo *obj)
| Get the autocapitalization type on the immodule.
EOAPI void | elm_obj_entry_editable_set (Eo *obj, Eina_Bool editable)
| Sets if the entry is to be editable or not.
EOAPI Eina_Bool | elm_obj_entry_editable_get (const Eo *obj)
| Get whether the entry is editable or not.
EOAPI void | elm_obj_entry_anchor_hover_style_set (Eo *obj, const char *style)
| Set the style that the hover should use.
EOAPI const char * | elm_obj_entry_anchor_hover_style_get (const Eo *obj)
| Get the style that the hover should use.
EOAPI void | elm_obj_entry_single_line_set (Eo *obj, Eina_Bool single_line)
| Sets the entry to single line mode.
EOAPI Eina_Bool | elm_obj_entry_single_line_get (const Eo *obj)
| Get whether the entry is set to be single line.
EOAPI void | elm_obj_entry_password_set (Eo *obj, Eina_Bool password)
| Sets the entry to password mode.
EOAPI Eina_Bool | elm_obj_entry_password_get (const Eo *obj)
| Get whether the entry is set to password mode.
EOAPI void | elm_obj_entry_input_panel_return_key_disabled_set (Eo *obj, Eina_Bool disabled)
| Set the return key on the input panel to be disabled.
EOAPI Eina_Bool | elm_obj_entry_input_panel_return_key_disabled_get (const Eo *obj)
| Get whether the return key on the input panel should be disabled or not.
EOAPI void | elm_obj_entry_autosave_set (Eo *obj, Eina_Bool auto_save)
| This sets the entry object to 'autosave' the loaded text file or not.
EOAPI Eina_Bool | elm_obj_entry_autosave_get (const Eo *obj)
| This gets the entry object's 'autosave' status.
EOAPI void | elm_obj_entry_anchor_hover_parent_set (Eo *obj, Efl_Canvas_Object *parent)
| Set the parent of the hover popup.
EOAPI Efl_Canvas_Object * | elm_obj_entry_anchor_hover_parent_get (const Eo *obj)
| Get the parent of the hover popup.
EOAPI void | elm_obj_entry_prediction_allow_set (Eo *obj, Eina_Bool prediction)
| Set whether the entry should allow to use the text prediction.
EOAPI Eina_Bool | elm_obj_entry_prediction_allow_get (const Eo *obj)
| Get whether the entry should allow to use the text prediction.
EOAPI void | elm_obj_entry_input_hint_set (Eo *obj, Elm_Input_Hints hints)
| Sets the input hint which allows input methods to fine-tune their behavior.
EOAPI Elm_Input_Hints | elm_obj_entry_input_hint_get (const Eo *obj)
| Gets the value of input hint.
EOAPI void | elm_obj_entry_input_panel_layout_set (Eo *obj, Elm_Input_Panel_Layout layout)
| Set the input panel layout of the entry.
EOAPI Elm_Input_Panel_Layout | elm_obj_entry_input_panel_layout_get (const Eo *obj)
| Get the input panel layout of the entry.
EOAPI void | elm_obj_entry_input_panel_return_key_type_set (Eo *obj, Elm_Input_Panel_Return_Key_Type return_key_type)
| Set the "return" key type.
EOAPI Elm_Input_Panel_Return_Key_Type | elm_obj_entry_input_panel_return_key_type_get (const Eo *obj)
| Get the "return" key type.
EOAPI void | elm_obj_entry_input_panel_enabled_set (Eo *obj, Eina_Bool enabled)
| Sets the attribute to show the input panel automatically.
EOAPI Eina_Bool | elm_obj_entry_input_panel_enabled_get (const Eo *obj)
| Get the attribute to show the input panel automatically.
EOAPI void | elm_obj_entry_line_wrap_set (Eo *obj, Elm_Wrap_Type wrap)
| Set the line wrap type to use on multi-line entries.
EOAPI Elm_Wrap_Type | elm_obj_entry_line_wrap_get (const Eo *obj)
| Get the wrap mode the entry was set to use.
EOAPI void | elm_obj_entry_cursor_pos_set (Eo *obj, int pos)
| Sets the cursor position in the entry to the given value.
EOAPI int | elm_obj_entry_cursor_pos_get (const Eo *obj)
| Get the current position of the cursor in the entry.
EOAPI void | elm_obj_entry_icon_visible_set (Eo *obj, Eina_Bool setting)
| Sets the visibility of the left-side widget of the entry, set by elm_object_part_content_set.
EOAPI void | elm_obj_entry_cursor_line_end_set (Eo *obj)
| This moves the cursor to the end of the current line.
EOAPI void | elm_obj_entry_select_region_set (Eo *obj, int start, int end)
| This selects a region of text within the entry.
EOAPI void | elm_obj_entry_select_region_get (const Eo *obj, int *start, int *end)
| Get the current position of the selection cursors in the entry.
EOAPI void | elm_obj_entry_input_panel_return_key_autoenabled_set (Eo *obj, Eina_Bool enabled)
| Set whether the return key on the input panel is disabled automatically when entry has no text.
EOAPI void | elm_obj_entry_end_visible_set (Eo *obj, Eina_Bool setting)
| Sets the visibility of the end widget of the entry, set by elm_object_part_content_set(ent, "end", content).
EOAPI void | elm_obj_entry_cursor_begin_set (Eo *obj)
| This moves the cursor to the beginning of the entry.
EOAPI void | elm_obj_entry_cursor_line_begin_set (Eo *obj)
| This moves the cursor to the beginning of the current line.
EOAPI void | elm_obj_entry_cursor_end_set (Eo *obj)
| This moves the cursor to the end of the entry.
EOAPI Efl_Canvas_Object * | elm_obj_entry_textblock_get (const Eo *obj)
| Returns the actual textblock object of the entry.
EOAPI Eina_Bool | elm_obj_entry_textblock_cursor_geometry_get (const Eo *obj, int *x, int *y, int *w, int *h)
| This function returns the geometry of the cursor.
EOAPI void * | elm_obj_entry_imf_context_get (const Eo *obj)
| Returns the input method context of the entry.
EOAPI Eina_Bool | elm_obj_entry_cursor_is_format_get (const Eo *obj)
| Get whether a format node exists at the current cursor position.
EOAPI char * | elm_obj_entry_textblock_cursor_content_get (const Eo *obj)
| Get the character pointed by the cursor at its current position.
EOAPI const char * | elm_obj_entry_selection_get (const Eo *obj)
| Get any selected text within the entry.
EOAPI Eina_Bool | elm_obj_entry_cursor_is_visible_format_get (const Eo *obj)
| Get if the current cursor position holds a visible format node.
EOAPI void | elm_obj_entry_select_allow_set (Eo *obj, Eina_Bool allow)
| Allow selection in the entry.
EOAPI Eina_Bool | elm_obj_entry_select_allow_get (const Eo *obj)
| Allow selection in the entry.
EOAPI Eina_Bool | elm_obj_entry_cursor_prev (Eo *obj)
| This moves the cursor one place to the left within the entry.
EOAPI void | elm_obj_entry_text_style_user_pop (Eo *obj)
| Remove the style in the top of user style stack.
EOAPI void | elm_obj_entry_item_provider_prepend (Eo *obj, Elm_Entry_Item_Provider_Cb func, void *data)
| This prepends a custom item provider to the list for that entry.
EOAPI void | elm_obj_entry_input_panel_show (Eo *obj)
| Show the input panel (virtual keyboard) based on the input panel property of entry such as layout, autocapital types, and so on.
EOAPI void | elm_obj_entry_imf_context_reset (Eo *obj)
| Reset the input method context of the entry if needed.
EOAPI void | elm_obj_entry_anchor_hover_end (Eo *obj)
| Ends the hover popup in the entry.
EOAPI void | elm_obj_entry_cursor_selection_begin (Eo *obj)
| This begins a selection within the entry as though the user were holding down the mouse button to make a selection.
EOAPI Eina_Bool | elm_obj_entry_cursor_down (Eo *obj)
| This moves the cursor one line down within the entry.
EOAPI void | elm_obj_entry_file_save (Eo *obj)
| This function writes any changes made to the file set with elm_entry_file_set.
EOAPI void | elm_obj_entry_selection_copy (Eo *obj)
| This executes a "copy" action on the selected text in the entry.
EOAPI void | elm_obj_entry_text_style_user_push (Eo *obj, const char *style)
| Push the style to the top of user style stack.
EOAPI void | elm_obj_entry_item_provider_remove (Eo *obj, Elm_Entry_Item_Provider_Cb func, void *data)
| This removes a custom item provider to the list for that entry.
EOAPI const char * | elm_obj_entry_text_style_user_peek (const Eo *obj)
| Get the style on the top of user style stack.
EOAPI void | elm_obj_entry_context_menu_clear (Eo *obj)
| This clears and frees the items in a entry's contextual (longpress) menu.
EOAPI Eina_Bool | elm_obj_entry_cursor_up (Eo *obj)
| This moves the cursor one line up within the entry.
EOAPI void | elm_obj_entry_insert (Eo *obj, const char *entry)
| Inserts the given text into the entry at the current cursor position.
EOAPI void | elm_obj_entry_input_panel_imdata_set (Eo *obj, const void *data, int len)
| Set the input panel-specific data to deliver to the input panel.
EOAPI void | elm_obj_entry_input_panel_imdata_get (const Eo *obj, void *data, int *len)
| Get the specific data of the current input panel.
EOAPI void | elm_obj_entry_selection_paste (Eo *obj)
| This executes a "paste" action in the entry.
EOAPI Eina_Bool | elm_obj_entry_cursor_next (Eo *obj)
| This moves the cursor one place to the right within the entry.
EOAPI void | elm_obj_entry_select_none (Eo *obj)
| This drops any existing text selection within the entry.
EOAPI void | elm_obj_entry_input_panel_hide (Eo *obj)
| Hide the input panel (virtual keyboard).
EOAPI void | elm_obj_entry_select_all (Eo *obj)
| This selects all text within the entry.
EOAPI void | elm_obj_entry_cursor_selection_end (Eo *obj)
| This ends a selection within the entry as though the user had just released the mouse button while making a selection.
EOAPI void | elm_obj_entry_selection_cut (Eo *obj)
| This executes a "cut" action on the selected text in the entry.
EOAPI Eina_Bool | elm_obj_entry_is_empty (const Eo *obj)
| Get whether the entry is empty.
EOAPI void | elm_obj_entry_markup_filter_remove (Eo *obj, Elm_Entry_Filter_Cb func, void *data)
| Remove a markup filter from the list.
EOAPI void | elm_obj_entry_item_provider_append (Eo *obj, Elm_Entry_Item_Provider_Cb func, void *data)
| This appends a custom item provider to the list for that entry.
EOAPI void | elm_obj_entry_markup_filter_append (Eo *obj, Elm_Entry_Filter_Cb func, void *data)
| Append a markup filter function for text inserted in the entry.
EOAPI void | elm_obj_entry_append (Eo *obj, const char *str)
| Appends `str` to the text of the entry.
EOAPI void | elm_obj_entry_context_menu_item_add (Eo *obj, const char *label, const char *icon_file, Elm_Icon_Type icon_type, Evas_Smart_Cb func, const void *data)
| This adds an item to the entry's contextual menu.
EOAPI void | elm_obj_entry_markup_filter_prepend (Eo *obj, Elm_Entry_Filter_Cb func, void *data)
| Prepend a markup filter function for text inserted in the entry.
EOAPI void | elm_obj_entry_prediction_hint_set (Eo *obj, const char *prediction_hint)
| Sets the prediction hint to use an intelligent reply suggestion service.
EOAPI Eina_Bool | elm_obj_entry_prediction_hint_hash_set (Eo *obj, const char *key, const char *value)
| Sets the prediction hint data at the specified key.
EOAPI Eina_Bool | elm_obj_entry_prediction_hint_hash_del (Eo *obj, const char *key)
| Removes the prediction hint data identified by a key.
void | elm_entry_scrollable_set (Elm_Entry *obj, Eina_Bool scroll)
| Enable or disable scrolling in entry.
Eina_Bool | elm_entry_scrollable_get (const Elm_Entry *obj)
| Get the scrollable state of the entry.
void | elm_entry_input_panel_show_on_demand_set (Elm_Entry *obj, Eina_Bool ondemand)
| Set the attribute to show the input panel in case of only a user's explicit Mouse Up event.
Eina_Bool | elm_entry_input_panel_show_on_demand_get (const Elm_Entry *obj)
| Get the attribute to show the input panel in case of only a user's explicit Mouse Up event.
void | elm_entry_context_menu_disabled_set (Elm_Entry *obj, Eina_Bool disabled)
| This disables the entry's contextual (longpress) menu.
Eina_Bool | elm_entry_context_menu_disabled_get (const Elm_Entry *obj)
| This returns whether the entry's contextual (longpress) menu is disabled.
void | elm_entry_cnp_mode_set (Elm_Entry *obj, Elm_Cnp_Mode cnp_mode)
| Control pasting of text and images for the widget.
Elm_Cnp_Mode | elm_entry_cnp_mode_get (const Elm_Entry *obj)
| Getting elm_entry text paste/drop mode.
void | elm_entry_file_text_format_set (Elm_Entry *obj, Elm_Text_Format format)
| Text format used to load and save the file, which could be plain text or markup text.
void | elm_entry_input_panel_language_set (Elm_Entry *obj, Elm_Input_Panel_Lang lang)
| Set the language mode of the input panel.
Elm_Input_Panel_Lang | elm_entry_input_panel_language_get (const Elm_Entry *obj)
| Get the language mode of the input panel.
void | elm_entry_selection_handler_disabled_set (Elm_Entry *obj, Eina_Bool disabled)
| This disabled the entry's selection handlers.
void | elm_entry_input_panel_layout_variation_set (Elm_Entry *obj, int variation)
| Set the input panel layout variation of the entry.
int | elm_entry_input_panel_layout_variation_get (const Elm_Entry *obj)
| Get the input panel layout variation of the entry.
void | elm_entry_autocapital_type_set (Elm_Entry *obj, Elm_Autocapital_Type autocapital_type)
| Set the autocapitalization type on the immodule.
Elm_Autocapital_Type | elm_entry_autocapital_type_get (const Elm_Entry *obj)
| Get the autocapitalization type on the immodule.
void | elm_entry_editable_set (Elm_Entry *obj, Eina_Bool editable)
| Sets if the entry is to be editable or not.
Eina_Bool | elm_entry_editable_get (const Elm_Entry *obj)
| Get whether the entry is editable or not.
void | elm_entry_anchor_hover_style_set (Elm_Entry *obj, const char *style)
| Set the style that the hover should use.
const char * | elm_entry_anchor_hover_style_get (const Elm_Entry *obj)
| Get the style that the hover should use.
void | elm_entry_single_line_set (Elm_Entry *obj, Eina_Bool single_line)
| Sets the entry to single line mode.
Eina_Bool | elm_entry_single_line_get (const Elm_Entry *obj)
| Get whether the entry is set to be single line.
void | elm_entry_password_set (Elm_Entry *obj, Eina_Bool password)
| Sets the entry to password mode.
Eina_Bool | elm_entry_password_get (const Elm_Entry *obj)
| Get whether the entry is set to password mode.
void | elm_entry_input_panel_return_key_disabled_set (Elm_Entry *obj, Eina_Bool disabled)
| Set the return key on the input panel to be disabled.
Eina_Bool | elm_entry_input_panel_return_key_disabled_get (const Elm_Entry *obj)
| Get whether the return key on the input panel should be disabled or not.
void | elm_entry_autosave_set (Elm_Entry *obj, Eina_Bool auto_save)
| This sets the entry object to 'autosave' the loaded text file or not.
Eina_Bool | elm_entry_autosave_get (const Elm_Entry *obj)
| This gets the entry object's 'autosave' status.
void | elm_entry_anchor_hover_parent_set (Elm_Entry *obj, Efl_Canvas_Object *parent)
| Set the parent of the hover popup.
Efl_Canvas_Object * | elm_entry_anchor_hover_parent_get (const Elm_Entry *obj)
| Get the parent of the hover popup.
void | elm_entry_prediction_allow_set (Elm_Entry *obj, Eina_Bool prediction)
| Set whether the entry should allow to use the text prediction.
Eina_Bool | elm_entry_prediction_allow_get (const Elm_Entry *obj)
| Get whether the entry should allow to use the text prediction.
void | elm_entry_input_hint_set (Elm_Entry *obj, Elm_Input_Hints hints)
| Sets the input hint which allows input methods to fine-tune their behavior.
Elm_Input_Hints | elm_entry_input_hint_get (const Elm_Entry *obj)
| Gets the value of input hint.
void | elm_entry_input_panel_layout_set (Elm_Entry *obj, Elm_Input_Panel_Layout layout)
| Set the input panel layout of the entry.
Elm_Input_Panel_Layout | elm_entry_input_panel_layout_get (const Elm_Entry *obj)
| Get the input panel layout of the entry.
void | elm_entry_input_panel_return_key_type_set (Elm_Entry *obj, Elm_Input_Panel_Return_Key_Type return_key_type)
| Set the "return" key type.
Elm_Input_Panel_Return_Key_Type | elm_entry_input_panel_return_key_type_get (const Elm_Entry *obj)
| Get the "return" key type.
void | elm_entry_input_panel_enabled_set (Elm_Entry *obj, Eina_Bool enabled)
| Sets the attribute to show the input panel automatically.
Eina_Bool | elm_entry_input_panel_enabled_get (const Elm_Entry *obj)
| Get the attribute to show the input panel automatically.
void | elm_entry_line_wrap_set (Elm_Entry *obj, Elm_Wrap_Type wrap)
| Set the line wrap type to use on multi-line entries.
Elm_Wrap_Type | elm_entry_line_wrap_get (const Elm_Entry *obj)
| Get the wrap mode the entry was set to use.
void | elm_entry_cursor_pos_set (Elm_Entry *obj, int pos)
| Sets the cursor position in the entry to the given value.
int | elm_entry_cursor_pos_get (const Elm_Entry *obj)
| Get the current position of the cursor in the entry.
void | elm_entry_icon_visible_set (Elm_Entry *obj, Eina_Bool setting)
| Sets the visibility of the left-side widget of the entry, set by elm_object_part_content_set.
void | elm_entry_cursor_line_end_set (Elm_Entry *obj)
| This moves the cursor to the end of the current line.
void | elm_entry_select_region_set (Elm_Entry *obj, int start, int end)
| This selects a region of text within the entry.
void | elm_entry_select_region_get (const Elm_Entry *obj, int *start, int *end)
| Get the current position of the selection cursors in the entry.
void | elm_entry_input_panel_return_key_autoenabled_set (Elm_Entry *obj, Eina_Bool enabled)
| Set whether the return key on the input panel is disabled automatically when entry has no text.
void | elm_entry_end_visible_set (Elm_Entry *obj, Eina_Bool setting)
| Sets the visibility of the end widget of the entry, set by elm_object_part_content_set(ent, "end", content).
void | elm_entry_cursor_begin_set (Elm_Entry *obj)
| This moves the cursor to the beginning of the entry.
void | elm_entry_cursor_line_begin_set (Elm_Entry *obj)
| This moves the cursor to the beginning of the current line.
void | elm_entry_cursor_end_set (Elm_Entry *obj)
| This moves the cursor to the end of the entry.
Efl_Canvas_Object * | elm_entry_textblock_get (const Elm_Entry *obj)
| Returns the actual textblock object of the entry.
Eina_Bool | elm_entry_cursor_geometry_get (const Elm_Entry *obj, int *x, int *y, int *w, int *h)
| This function returns the geometry of the cursor.
void * | elm_entry_imf_context_get (const Elm_Entry *obj)
| Returns the input method context of the entry.
Eina_Bool | elm_entry_cursor_is_format_get (const Elm_Entry *obj)
| Get whether a format node exists at the current cursor position.
char * | elm_entry_cursor_content_get (const Elm_Entry *obj)
| Get the character pointed by the cursor at its current position.
const char * | elm_entry_selection_get (const Elm_Entry *obj)
| Get any selected text within the entry.
Eina_Bool | elm_entry_cursor_is_visible_format_get (const Elm_Entry *obj)
| Get if the current cursor position holds a visible format node.
void | elm_entry_select_allow_set (Elm_Entry *obj, Eina_Bool allow)
| Allow selection in the entry.
Eina_Bool | elm_entry_select_allow_get (const Elm_Entry *obj)
| Allow selection in the entry.
Eina_Bool | elm_entry_cursor_prev (Elm_Entry *obj)
| This moves the cursor one place to the left within the entry.
void | elm_entry_text_style_user_pop (Elm_Entry *obj)
| Remove the style in the top of user style stack.
void | elm_entry_item_provider_prepend (Elm_Entry *obj, Elm_Entry_Item_Provider_Cb func, void *data)
| This prepends a custom item provider to the list for that entry.
void | elm_entry_input_panel_show (Elm_Entry *obj)
| Show the input panel (virtual keyboard) based on the input panel property of entry such as layout, autocapital types, and so on.
void | elm_entry_imf_context_reset (Elm_Entry *obj)
| Reset the input method context of the entry if needed.
void | elm_entry_anchor_hover_end (Elm_Entry *obj)
| Ends the hover popup in the entry.
void | elm_entry_cursor_selection_begin (Elm_Entry *obj)
| This begins a selection within the entry as though the user were holding down the mouse button to make a selection.
Eina_Bool | elm_entry_cursor_down (Elm_Entry *obj)
| This moves the cursor one line down within the entry.
void | elm_entry_file_save (Elm_Entry *obj)
| This function writes any changes made to the file set with elm_entry_file_set.
void | elm_entry_selection_copy (Elm_Entry *obj)
| This executes a "copy" action on the selected text in the entry.
void | elm_entry_text_style_user_push (Elm_Entry *obj, const char *style)
| Push the style to the top of user style stack.
void | elm_entry_item_provider_remove (Elm_Entry *obj, Elm_Entry_Item_Provider_Cb func, void *data)
| This removes a custom item provider to the list for that entry.
const char * | elm_entry_text_style_user_peek (const Elm_Entry *obj)
| Get the style on the top of user style stack.
void | elm_entry_context_menu_clear (Elm_Entry *obj)
| This clears and frees the items in a entry's contextual (longpress) menu.
Eina_Bool | elm_entry_cursor_up (Elm_Entry *obj)
| This moves the cursor one line up within the entry.
void | elm_entry_entry_insert (Elm_Entry *obj, const char *entry)
| Inserts the given text into the entry at the current cursor position.
void | elm_entry_input_panel_imdata_set (Elm_Entry *obj, const void *data, int len)
| Set the input panel-specific data to deliver to the input panel.
void | elm_entry_input_panel_imdata_get (const Elm_Entry *obj, void *data, int *len)
| Get the specific data of the current input panel.
void | elm_entry_selection_paste (Elm_Entry *obj)
| This executes a "paste" action in the entry.
Eina_Bool | elm_entry_cursor_next (Elm_Entry *obj)
| This moves the cursor one place to the right within the entry.
void | elm_entry_select_none (Elm_Entry *obj)
| This drops any existing text selection within the entry.
void | elm_entry_input_panel_hide (Elm_Entry *obj)
| Hide the input panel (virtual keyboard).
void | elm_entry_select_all (Elm_Entry *obj)
| This selects all text within the entry.
void | elm_entry_cursor_selection_end (Elm_Entry *obj)
| This ends a selection within the entry as though the user had just released the mouse button while making a selection.
void | elm_entry_selection_cut (Elm_Entry *obj)
| This executes a "cut" action on the selected text in the entry.
Eina_Bool | elm_entry_is_empty (const Elm_Entry *obj)
| Get whether the entry is empty.
void | elm_entry_markup_filter_remove (Elm_Entry *obj, Elm_Entry_Filter_Cb func, void *data)
| Remove a markup filter from the list.
void | elm_entry_item_provider_append (Elm_Entry *obj, Elm_Entry_Item_Provider_Cb func, void *data)
| This appends a custom item provider to the list for that entry.
void | elm_entry_markup_filter_append (Elm_Entry *obj, Elm_Entry_Filter_Cb func, void *data)
| Append a markup filter function for text inserted in the entry.
void | elm_entry_entry_append (Elm_Entry *obj, const char *str)
| Appends `str` to the text of the entry.
void | elm_entry_context_menu_item_add (Elm_Entry *obj, const char *label, const char *icon_file, Elm_Icon_Type icon_type, Evas_Smart_Cb func, const void *data)
| This adds an item to the entry's contextual menu.
void | elm_entry_markup_filter_prepend (Elm_Entry *obj, Elm_Entry_Filter_Cb func, void *data)
| Prepend a markup filter function for text inserted in the entry.
void | elm_entry_prediction_hint_set (Elm_Entry *obj, const char *prediction_hint)
| Sets the prediction hint to use an intelligent reply suggestion service.
Eina_Bool | elm_entry_prediction_hint_hash_set (Elm_Entry *obj, const char *key, const char *value)
| Sets the prediction hint data at the specified key.
Eina_Bool | elm_entry_prediction_hint_hash_del (Elm_Entry *obj, const char *key)
| Removes the prediction hint data identified by a key.
Evas_Object * | elm_entry_add (Evas_Object *parent)
| This adds an entry to `parent` object.
void | elm_entry_entry_set (Evas_Object *obj, const char *entry)
| This sets the text displayed within the entry to `entry`.
const char * | elm_entry_entry_get (const Evas_Object *obj)
| This returns the text currently shown in object `entry`.
Eina_Bool | elm_entry_file_set (Evas_Object *obj, const char *file, Elm_Text_Format format)
| This sets the file (and implicitly loads it) for the text to display and then edit.
void | elm_entry_file_get (const Evas_Object *obj, const char **file, Elm_Text_Format *format)
| Get the file being edited by the entry.
void | elm_entry_calc_force (Evas_Object *obj)
| Forces calculation of the entry size and text layouting.

## Detailed Description

An entry is a convenience widget which shows a box that the user can enter text into. Entries by default don't scroll, so they grow to accommodate the entire text, resizing the parent window as needed. This can be changed with the elm_entry_scrollable_set() function.

They can also be single line or multi line (the default) and when set to multi line mode they support text wrapping in any of the modes indicated by Elm_Wrap_Type.

Other features include password mode, filtering of inserted text with elm_entry_markup_filter_append() and related functions, inline "items" and formatted markup text.

This widget inherits from the Layout one, so that all the functions acting on it also work for entry objects (since 1.8).

This widget implements the The Elementary Scrollable Interface interface, so that all (non-deprecated) functions for the base Elm_Scroller widget also work for entries (since 1.8).

Some calls on the entry's API are marked as deprecated, as they just wrap the scrollable widgets counterpart functions. Use the ones we point you to, for each case of deprecation here, instead – eventually the deprecated ones will be discarded (next major release).

# Formatted text

The markup tags supported by the Entry are defined by the theme, but even when writing new themes or extensions it's a good idea to stick to a sane default, to maintain coherency and avoid application breakages. Currently defined by the default theme are the following tags:

- <br>: Inserts a line break.
- <ps>: Inserts a paragraph separator. This is preferred over line breaks.
- <tab>: Inserts a tab.
- <em>...</em>: Emphasis. Sets the oblique style for the enclosed text.
- <b>...</b>: Sets the bold style for the enclosed text.
- <link>...</link>: Underlines the enclosed text.
- <hilight>...</hilight>: Highlights the enclosed text.
- <title>...</title>: Main title.
- <subtitle>...</subtitle>: Secondary level title.
- <bigger>...</bigger>: A really big text, not so big as the titles.
- <big>...</big>: Big text.
- <small>...</small>: Small text.
- <smaller>...</smaller>: Really small text, at the point of unreadability.

Entry also support tags for code syntax highlight. Note that this does not mean that the entry will automatically perform code highlight, application are responsable of applying the correct tag to code blocks. The default theme define the following tags:

- <code>...</code>: Monospace font without shadows.
- <comment>...</comment>: Code comments.
- <string>...</string>: Strings of text.
- <number>...</number>: Numeric expression (ex: 1, 2, 0.34, etc)
- <brace>...</brace>: Braces used for code syntax.
- <type>...</type>: Variables types (ex: int, float, char, Evas_Object, etc)
- <class>...</class>: Class names, when defined, not when used.
- <function>...</function>: Function names, when defined, not called.
- <param>...</param>: Generic parameters.
- <keyword>...</keyword>: Language keywords (ex: return, NULL, while, for, etc)
- <preprocessor>...</preprocessor>: Preprocessors definitions.
- <line_added>...</line_added>: Diff added lines.
- <line_removed>...</line_removed>: Diff removed lines.
- <line_changed>...</line_changed>: Diff changed lines.

# Special markups

Besides those used to format text, entries support two special markup tags used to insert click-able portions of text or items inlined within the text.

## Anchors

Anchors are similar to HTML anchors. Text can be surrounded by <a> and </a> tags and an event will be generated when this text is clicked, like this:

This text is outside <a href=anc-01>but this one is an anchor</a>

The `href` attribute in the opening tag gives the name that will be used to identify the anchor and it can be any valid utf8 string.

When an anchor is clicked, an `"anchor,clicked"` signal is emitted with an Elm_Entry_Anchor_Info in the `event_info` parameter for the callback function. The same applies for "anchor,in" (mouse in), "anchor,out" (mouse out), "anchor,down" (mouse down), and "anchor,up" (mouse up) events on an anchor.

## Items

Inlined in the text, any other `Evas_Object` can be inserted by using <item> tags this way:

<item size=16x16 vsize=full href=emoticon/haha></item>

Just like with anchors, the `href` identifies each item, but these need, in addition, to indicate their size, which is done using any one of `size`, `absize` or `relsize` attributes. These attributes take their value in the WxH format, where W is the width and H the height of the item.

- absize: Absolute pixel size for the item. Whatever value is set will be the item's size regardless of any scale value the object may have been set to. The final line height will be adjusted to fit larger items.
- size: Similar to `absize`, but it's adjusted to the scale value set for the object.
- relsize: Size is adjusted for the item to fit within the current line height.

Besides their size, items are specified a `vsize` value that affects how their final size and position are calculated. The possible values are:

- ascent: Item will be placed within the line's baseline and its ascent. That is, the height between the line where all characters are positioned and the highest point in the line. For `size` and `absize` items, the descent value will be added to the total line height to make them fit. `relsize` items will be adjusted to fit within this space.
- full: Items will be placed between the descent and ascent, or the lowest point in the line and its highest.

The next image shows different configurations of items and how the previously mentioned options affect their sizes. In all cases, the green line indicates the ascent, blue for the baseline and red for the descent.

And another one to show how size differs from absize. In the first one, the scale value is set to 1.0, while the second one is using one of 2.0.

After the size for an item is calculated, the entry will request an object to place in its space. For this, the functions set with elm_entry_item_provider_append() and related functions will be called in order until one of them returns a `non-NULL` value. If no providers are available, or all of them return `NULL`, then the entry falls back to one of the internal defaults, provided the name matches with one of them.

All of the following are currently supported:

- emoticon/angry
- emoticon/angry-shout
- emoticon/crazy-laugh
- emoticon/evil-laugh
- emoticon/evil
- emoticon/goggle-smile
- emoticon/grumpy
- emoticon/grumpy-smile
- emoticon/guilty
- emoticon/guilty-smile
- emoticon/haha
- emoticon/half-smile
- emoticon/happy-panting
- emoticon/happy
- emoticon/indifferent
- emoticon/kiss
- emoticon/knowing-grin
- emoticon/laugh
- emoticon/little-bit-sorry
- emoticon/love-lots
- emoticon/love
- emoticon/minimal-smile
- emoticon/not-happy
- emoticon/not-impressed
- emoticon/omg
- emoticon/opensmile
- emoticon/smile
- emoticon/sorry
- emoticon/squint-laugh
- emoticon/surprised
- emoticon/suspicious
- emoticon/tongue-dangling
- emoticon/tongue-poke
- emoticon/uh
- emoticon/unhappy
- emoticon/very-sorry
- emoticon/what
- emoticon/wink
- emoticon/worried
- emoticon/wtf

Alternatively, an item may reference an image by its path, using the URI form `file:///path/to/an/image.png` and the entry will then use that image for the item.

# Setting entry's style

There are 2 major ways to change the entry's style:

- Theme - set the "base" field to the desired style.
- User style - Pushing overrides to the theme style to the textblock object by using evas_object_textblock_style_user_push().

You should modify the theme when you would like to change the style for aesthetic reasons. While the user style should be changed when you would like to change the style to something specific defined at run-time, e.g, setting font or font size in a text editor.

# Loading and saving files

Entries have convenience functions to load text from a file and save changes back to it after a short delay. The automatic saving is enabled by default, but can be disabled with elm_entry_autosave_set() and files can be loaded directly as plain text or have any markup in them recognized. See elm_entry_file_set() for more details.

# Emitted signals

This widget emits the following signals, besides the ones sent from Layout :

- "aborted": The escape key was pressed on a single line entry. (since 1.7)
- "activated": The enter key was pressed on a single line entry.
- "anchor,clicked": An anchor has been clicked. The event_info parameter for the callback will be an Elm_Entry_Anchor_Info.
- "anchor,down": Mouse button has been pressed on an anchor. The event_info parameter for the callback will be an Elm_Entry_Anchor_Info.
- "anchor,hover,opened": The anchor is clicked.
- "anchor,in": Mouse cursor has moved into an anchor. The event_info parameter for the callback will be an Elm_Entry_Anchor_Info.
- "anchor,out": Mouse cursor has moved out of an anchor. The event_info parameter for the callback will be an Elm_Entry_Anchor_Info.
- "anchor,up": Mouse button has been unpressed on an anchor. The event_info parameter for the callback will be an Elm_Entry_Anchor_Info.
- "changed": The text within the entry was changed.
- "changed,user": The text within the entry was changed because of user interaction.
- "clicked": The entry has been clicked (mouse press and release).
- "clicked,double": The entry has been double clicked.
- "clicked,triple": The entry has been triple clicked.
- "cursor,changed": The cursor has changed position.
- "cursor,changed,manual": The cursor has changed position manually.
- "focused": The entry has received focus.
- "unfocused": The entry has lost focus.
- "language,changed": Program language changed.
- "longpressed": A mouse button has been pressed and held for a couple
- "maxlength,reached": Called when a maximum length is reached.
- "preedit,changed": The preedit string has changed.
- "press": A mouse button has been pressed on the entry. seconds.
- "redo,request": Called on redo request.
- "selection,changed": The current selection has changed.
- "selection,cleared": The current selection has been cleared.
- "selection,copy": A copy of the selected text into the clipboard was requested.
- "selection,cut": A cut of the selected text into the clipboard was requested.
- "selection,paste": A paste of the clipboard contents was requested.
- "selection,start": A selection has begun and no previous selection existed.
- "text,set,done": Whole text has been set to the entry.
- "theme,changed": Called when the theme is changed.
- "undo,request": Called on undo request.
- "rejected": Called when some of inputs are rejected by the filter. (since 1.9)

Default content parts of the entry items that you can use for are:

- "icon" - An icon in the entry
- "end" - A content in the end of the entry

Default text parts of the entry that you can use for are:

- "default" - A text of the entry
- "guide" - A placeholder of the entry

Supported elm_object common APIs.

- elm_object_signal_emit
- elm_object_part_text_set
- elm_object_part_text_get
- elm_object_part_content_set
- elm_object_part_content_get
- elm_object_part_content_unset
- elm_object_signal_callback_add
- elm_object_signal_callback_del
- elm_object_disabled_set
- elm_object_disabled_get

# entry-examples

An overview of the Entry API can be seen in Entry - Example of simple editing

## Macro Definition Documentation

## ELM_ENTRY_EVENT_CHANGED_USER

#define ELM_ENTRY_EVENT_CHANGED_USER (&(_ELM_ENTRY_EVENT_CHANGED_USER))

Called when the object changed due to user interaction.

Returns
  Elm_Entry_Change_Info

## ELM_ENTRY_EVENT_VALIDATE

#define ELM_ENTRY_EVENT_VALIDATE (&(_ELM_ENTRY_EVENT_VALIDATE))

Called when validating.

Returns
  Elm_Validate_Content

## ELM_ENTRY_EVENT_ANCHOR_CLICKED

#define ELM_ENTRY_EVENT_ANCHOR_CLICKED (&(_ELM_ENTRY_EVENT_ANCHOR_CLICKED))

Called when anchor was clicked.

Returns
  Elm_Entry_Anchor_Info

## ELM_ENTRY_EVENT_ANCHOR_DOWN

#define ELM_ENTRY_EVENT_ANCHOR_DOWN (&(_ELM_ENTRY_EVENT_ANCHOR_DOWN))

Called on anchor down.

Returns
  Elm_Entry_Anchor_Info

## ELM_ENTRY_EVENT_ANCHOR_HOVER_OPENED

#define ELM_ENTRY_EVENT_ANCHOR_HOVER_OPENED (&(_ELM_ENTRY_EVENT_ANCHOR_HOVER_OPENED))

Called when hover opened.

Returns
  Elm_Entry_Anchor_Hover_Info

## ELM_ENTRY_EVENT_ANCHOR_IN

#define ELM_ENTRY_EVENT_ANCHOR_IN (&(_ELM_ENTRY_EVENT_ANCHOR_IN))

Called on anchor in.

Returns
  Elm_Entry_Anchor_Info

## ELM_ENTRY_EVENT_ANCHOR_OUT

#define ELM_ENTRY_EVENT_ANCHOR_OUT (&(_ELM_ENTRY_EVENT_ANCHOR_OUT))

Called on anchor out.

Returns
  Elm_Entry_Anchor_Info

## ELM_ENTRY_EVENT_ANCHOR_UP

#define ELM_ENTRY_EVENT_ANCHOR_UP (&(_ELM_ENTRY_EVENT_ANCHOR_UP))

called on anchor up

Returns
  Elm_Entry_Anchor_Info

## Typedef Documentation

## Elm_Entry_Context_Menu_Item

typedef struct _Elm_Entry_Context_Menu_Item Elm_Entry_Context_Menu_Item

Type of contextual item that can be added in to long press menu.

Since
  1.8

## Elm_Entry_Item_Provider_Cb

typedef Evas_Object *(* Elm_Entry_Item_Provider_Cb) (void *data, Evas_Object *entry, const char *item)

This callback type is used to provide items.

If it returns an object handle other than NULL (it should create an object to do this), then this object is used to replace the current item. If not the next provider is called until one provides an item object, or the default provider in entry does.

Parameters

  data | The data specified as the last param when adding the provider
  entry | The entry object
  text | A pointer to the item href string in the text

Returns
  The object to be placed in the entry like an icon, or other element

See also
  elm_entry_item_provider_append
  elm_entry_item_provider_prepend
  elm_entry_item_provider_remove

## Elm_Entry_Filter_Cb

typedef void(* Elm_Entry_Filter_Cb) (void *data, Evas_Object *entry, char **text)

This callback type is used by entry filters to modify text.

Parameters

  data | The data specified as the last param when adding the filter
  entry | The entry object
  text | A pointer to the location of the text being filtered. The type of text is always markup. This data can be modified, but any additional allocations must be managed by the user.

See also
  elm_entry_markup_filter_append
  elm_entry_markup_filter_prepend
  elm_entry_markup_filter_remove

## Elm_Entry_Change_Info

typedef Edje_Entry_Change_Info Elm_Entry_Change_Info

This corresponds to Edje_Entry_Change_Info.

Includes information about a change in the entry.

## Enumeration Type Documentation

## Elm_Input_Panel_Layout_Normal_Variation

enum Elm_Input_Panel_Layout_Normal_Variation

Enumeration for defining the types of Elm Input Panel Layout for normal variation.

Since
  1.12

Enumerator

ELM_INPUT_PANEL_LAYOUT_NORMAL_VARIATION_NORMAL

The plain normal layout.

Since
  1.12

ELM_INPUT_PANEL_LAYOUT_NORMAL_VARIATION_FILENAME

Filename layout.

Symbols such as '/' should be disabled.

Since
  1.12

ELM_INPUT_PANEL_LAYOUT_NORMAL_VARIATION_PERSON_NAME

The name of a person.

Since
  1.12

## Elm_Input_Panel_Layout_Numberonly_Variation

enum Elm_Input_Panel_Layout_Numberonly_Variation

Enumeration for defining the types of Elm Input Panel Layout for number only variation.

Since
  1.8

Enumerator

ELM_INPUT_PANEL_LAYOUT_NUMBERONLY_VARIATION_NORMAL

The plain normal number layout.

Since
  1.8

ELM_INPUT_PANEL_LAYOUT_NUMBERONLY_VARIATION_SIGNED

The number layout to allow a positive or negative sign at the start.

Since
  1.8

ELM_INPUT_PANEL_LAYOUT_NUMBERONLY_VARIATION_DECIMAL

The number layout to allow decimal point to provide fractional value.

Since
  1.8

ELM_INPUT_PANEL_LAYOUT_NUMBERONLY_VARIATION_SIGNED_AND_DECIMAL

The number layout to allow decimal point and negative sign.

Since
  1.8

## Elm_Input_Panel_Layout_Password_Variation

enum Elm_Input_Panel_Layout_Password_Variation

Enumeration for defining the types of Elm Input Panel Layout for password variation.

Since
  1.12

Enumerator

ELM_INPUT_PANEL_LAYOUT_PASSWORD_VARIATION_NORMAL

The normal password layout.

Since
  1.12

ELM_INPUT_PANEL_LAYOUT_PASSWORD_VARIATION_NUMBERONLY

The password layout to allow only number.

Since
  1.12

## Function Documentation

## elm_config_context_menu_disabled_get()

Eina_Bool elm_config_context_menu_disabled_get | ( | void |  | ) |

Get enable status of context menu disabled.

See also
  elm_config_context_menu_disabled_set()

Returns
  `EINA_TRUE` if context menu is disabled, otherwise `EINA_FALSE`.

Since
  1.17

## elm_config_context_menu_disabled_set()

void elm_config_context_menu_disabled_set | ( | Eina_Bool | disabled | ) |

Enable or disable the context menu in entries.

Parameters

  disabled | disable context menu if `EINA_TRUE`, enable otherwise

See also
  elm_config_context_menu_disabled_get()

Since
  1.17

References EINA_TRUE.

## elm_scrolled_entry_cnp_textonly_set()

EINA_DEPRECATED void elm_scrolled_entry_cnp_textonly_set | ( | Evas_Object * | obj,
|  | Eina_Bool | textonly )

This function sets the entry to textonly mode.

Parameters

  obj | The entry object
  textonly | the mode of textonly.

Deprecated

References ELM_CNP_MODE_MARKUP, ELM_CNP_MODE_NO_IMAGE, and elm_entry_cnp_mode_set().

## elm_scrolled_entry_cnp_textonly_get()

EINA_DEPRECATED Eina_Bool elm_scrolled_entry_cnp_textonly_get | ( | Evas_Object * | obj | ) |

This function gets the current textonly mode of the entry.

Parameters

  obj | The entry object

Returns
  `EINA_TRUE` textonly mode, `EINA_FALSE` not textonly mode

Deprecated

References ELM_CNP_MODE_MARKUP, and elm_entry_cnp_mode_get().

## elm_entry_scrollbar_policy_set()

EINA_DEPRECATED void elm_entry_scrollbar_policy_set | ( | Evas_Object * | obj,
|  | Elm_Scroller_Policy | h,
|  | Elm_Scroller_Policy | v )

This sets the entry's scrollbar policy (i.e.

enabling/disabling them).

Setting an entry to single-line mode with elm_entry_single_line_set() will automatically disable the display of scrollbars when the entry moves inside its scroller.

Parameters

  obj | The entry object
  h | The horizontal scrollbar policy to apply
  v | The vertical scrollbar policy to apply

Deprecated
  Use elm_scroller_policy_set() instead.

## elm_entry_bounce_set()

EINA_DEPRECATED void elm_entry_bounce_set | ( | Evas_Object * | obj,
|  | Eina_Bool | h_bounce,
|  | Eina_Bool | v_bounce )

This enables/disables bouncing within the entry.

This function sets whether the entry will bounce when scrolling reaches the end of the contained entry.

Parameters

  obj | The entry object
  h_bounce | The horizontal bounce state
  v_bounce | The vertical bounce state

Deprecated
  Use elm_scroller_bounce_set() instead.

## elm_entry_bounce_get()

EINA_DEPRECATED void elm_entry_bounce_get | ( | const Evas_Object * | obj,
|  | Eina_Bool * | h_bounce,
|  | Eina_Bool * | v_bounce )

Get the bounce mode.

Parameters

  obj | The Entry object
  h_bounce | Allow bounce horizontally
  v_bounce | Allow bounce vertically

Deprecated
  Use elm_scroller_bounce_get() instead.

## elm_entry_markup_to_utf8()

char * elm_entry_markup_to_utf8 | ( | const char * | s | ) |

This converts a markup (HTML-like) string into UTF-8.

The returned string is a malloc'ed buffer and it should be freed when not needed anymore.

Parameters

  s | The string (in markup) to be converted

Returns
  The converted string (in UTF-8). It should be freed.

Referenced by elm_entry_filter_accept_set(), and elm_entry_filter_limit_size().

## elm_entry_utf8_to_markup()

char * elm_entry_utf8_to_markup | ( | const char * | s | ) |

This converts a UTF-8 string into markup (HTML-like).

The returned string is a malloc'ed buffer and it should be freed when not needed anymore.

Parameters

  s | The string (in UTF-8) to be converted

Returns
  The converted string (in markup). It should be freed.

For example, passing "<align=center>hello</align>&gt;" will return "&lt;align=center&gt;hello&lt;/align&gt; &amp;gt;". This is useful when you want to display "&" in label, entry, and some widgets which use textblock internally.

## elm_entry_filter_limit_size()

void elm_entry_filter_limit_size | ( | void * | data,
|  | Evas_Object * | entry,
|  | char ** | text )

Filter inserted text based on user defined character and byte limits.

Add this filter to an entry to limit the characters that it will accept based the contents of the provided Elm_Entry_Filter_Limit_Size. The function works on the UTF-8 representation of the string, converting it from the set markup, thus not accounting for any format in it.

Parameters

  [in] | data | The data passed to this function.
  [in] | entry | The object.
  [in,out] | text | The entry's text to limit size

The user must create an Elm_Entry_Filter_Limit_Size structure and pass it as data when setting the filter. In it, it's possible to set limits by character count or bytes (any of them is disabled if 0), and both can be set at the same time. In that case, it first checks for characters, then bytes. The Elm_Entry_Filter_Limit_Size structure must be alive and valid for as long as the entry is alive AND the elm_entry_filter_limit_size filter is set.

The function will cut the inserted text in order to allow only the first number of characters that are still allowed. The cut is made in characters, even when limiting by bytes, in order to always contain valid ones and avoid half unicode characters making it in.

This filter, like any others, does not apply when setting the entry text directly with elm_object_text_set().

References EINA_SAFETY_ON_NULL_RETURN, ELM_ENTRY_EVENT_MAXLENGTH_REACHED, elm_entry_markup_to_utf8(), and evas_string_char_len_get().

## elm_entry_filter_accept_set()

void elm_entry_filter_accept_set | ( | void * | data,
|  | Evas_Object * | entry,
|  | char ** | text )

Filter inserted text based on accepted or rejected sets of characters.

Add this filter to an entry to restrict the set of accepted characters based on the sets in the provided Elm_Entry_Filter_Accept_Set. This structure contains both accepted and rejected sets, but they are mutually exclusive. This structure must be available for as long as the entry is alive AND the elm_entry_filter_accept_set is being used.

Parameters

  [in] | data | The data passed to this function.
  [in] | entry | The object.
  [in,out] | text | The entry's text to accept or reject filter

The `accepted` set takes preference, so if it is set, the filter will only work based on the accepted characters, ignoring anything in the `rejected` value. If `accepted` is `NULL`, then `rejected` is used.

In both cases, the function filters by matching utf8 characters to the raw markup text, so it can be used to remove formatting tags.

This filter, like any others, does not apply when setting the entry text directly with elm_object_text_set()

References _Elm_Entry_Filter_Accept_Set::accepted, EINA_FALSE, EINA_SAFETY_ON_NULL_RETURN, EINA_TRUE, ELM_ENTRY_EVENT_REJECTED, elm_entry_markup_to_utf8(), evas_string_char_next_get(), and _Elm_Entry_Filter_Accept_Set::rejected.

## elm_entry_context_menu_item_label_get()

const char * elm_entry_context_menu_item_label_get | ( | const Elm_Entry_Context_Menu_Item * | item | ) |

Get the text of the contextual menu item of entry.

Parameters

  item | The item to get the label

Returns
  The text of contextual menu item

See also
  elm_entry_context_menu_item_add()

Since
  1.8

## elm_entry_context_menu_item_icon_get()

void elm_entry_context_menu_item_icon_get | ( | const Elm_Entry_Context_Menu_Item * | item,
|  | const char ** | icon_file,
|  | const char ** | icon_group,
|  | Elm_Icon_Type * | icon_type )

Get the icon object packed in the contextual menu item of entry.

Parameters

  item | The item to get the icon from
  icon_file | The image file path on disk used for the icon or standard icon name
  icon_group | The edje group used if `icon_file` is an edje file. NULL if the icon is not an edje file
  icon_type | The icon type

See also
  elm_entry_context_menu_item_add()

Since
  1.8

## elm_obj_entry_scrollable_set()

EOAPI void elm_obj_entry_scrollable_set | ( | Eo * | obj,
|  | Eina_Bool | scroll )

Enable or disable scrolling in entry.

Normally the entry is not scrollable unless you enable it with this call.

Parameters

  [in] | obj | The object.
  [in] | scroll | `true` if it is to be scrollable, `false` otherwise.

Referenced by elm_entry_scrollable_set().

## elm_obj_entry_scrollable_get()

EOAPI Eina_Bool elm_obj_entry_scrollable_get | ( | const Eo * | obj | ) |

Get the scrollable state of the entry.

Normally the entry is not scrollable. This gets the scrollable state of the entry.

Parameters

  [in] | obj | The object.

Returns
  `true` if it is to be scrollable, `false` otherwise.

Referenced by elm_entry_scrollable_get().

## elm_obj_entry_input_panel_show_on_demand_set()

EOAPI void elm_obj_entry_input_panel_show_on_demand_set | ( | Eo * | obj,
|  | Eina_Bool | ondemand )

Set the attribute to show the input panel in case of only a user's explicit Mouse Up event.

It doesn't request to show the input panel even though it has focus.

Parameters

  [in] | obj | The object.
  [in] | ondemand | If `true`, the input panel will be shown in case of only Mouse up event. (Focus event will be ignored.)

Since
  1.9

Referenced by elm_entry_input_panel_show_on_demand_set().

## elm_obj_entry_input_panel_show_on_demand_get()

EOAPI Eina_Bool elm_obj_entry_input_panel_show_on_demand_get | ( | const Eo * | obj | ) |

Get the attribute to show the input panel in case of only a user's explicit Mouse Up event.

Parameters

  [in] | obj | The object.

Returns
  If `true`, the input panel will be shown in case of only Mouse up event. (Focus event will be ignored.)

Since
  1.9

Referenced by elm_entry_input_panel_show_on_demand_get().

## elm_obj_entry_context_menu_disabled_set()

EOAPI void elm_obj_entry_context_menu_disabled_set | ( | Eo * | obj,
|  | Eina_Bool | disabled )

This disables the entry's contextual (longpress) menu.

Parameters

  [in] | obj | The object.
  [in] | disabled | If `true`, the menu is disabled.

Referenced by elm_entry_context_menu_disabled_set().

## elm_obj_entry_context_menu_disabled_get()

EOAPI Eina_Bool elm_obj_entry_context_menu_disabled_get | ( | const Eo * | obj | ) |

This returns whether the entry's contextual (longpress) menu is disabled.

Parameters

  [in] | obj | The object.

Returns
  If `true`, the menu is disabled.

Referenced by elm_entry_context_menu_disabled_get().

## elm_obj_entry_cnp_mode_set()

EOAPI void elm_obj_entry_cnp_mode_set | ( | Eo * | obj,
|  | Elm_Cnp_Mode | cnp_mode )

Control pasting of text and images for the widget.

Normally the entry allows both text and images to be pasted. By setting cnp_mode to be ELM_CNP_MODE_NO_IMAGE, this prevents images from being copy or past. By setting cnp_mode to be ELM_CNP_MODE_PLAINTEXT, this remove all tags in text .

Note
  This only changes the behaviour of text.

Parameters

  [in] | obj | The object.
  [in] | cnp_mode | One of Elm_Cnp_Mode: ELM_CNP_MODE_MARKUP, ELM_CNP_MODE_NO_IMAGE, ELM_CNP_MODE_PLAINTEXT.

Referenced by elm_entry_cnp_mode_set().

## elm_obj_entry_cnp_mode_get()

EOAPI Elm_Cnp_Mode elm_obj_entry_cnp_mode_get | ( | const Eo * | obj | ) |

Getting elm_entry text paste/drop mode.

Normally the entry allows both text and images to be pasted. This gets the copy & paste mode of the entry.

Parameters

  [in] | obj | The object.

Returns
  One of Elm_Cnp_Mode: ELM_CNP_MODE_MARKUP, ELM_CNP_MODE_NO_IMAGE, ELM_CNP_MODE_PLAINTEXT.

Referenced by elm_entry_cnp_mode_get().

## elm_obj_entry_file_text_format_set()

EOAPI void elm_obj_entry_file_text_format_set | ( | Eo * | obj,
|  | Elm_Text_Format | format )

Text format used to load and save the file, which could be plain text or markup text.

Default is `ELM_TEXT_FORMAT_PLAIN_UTF8`, if you want to use `ELM_TEXT_FORMAT_MARKUP_UTF8` then you need to set the text format before calling efl_file_load.

You could also set it before a call to elm_obj_entry_file_save in order to save with the given format.

Use it before calling efl_file_load or elm_obj_entry_file_save.

Parameters

  [in] | obj | The object.
  [in] | format | The file format

Referenced by elm_entry_file_set(), and elm_entry_file_text_format_set().

## elm_obj_entry_input_panel_language_set()

EOAPI void elm_obj_entry_input_panel_language_set | ( | Eo * | obj,
|  | Elm_Input_Panel_Lang | lang )

Set the language mode of the input panel.

This API can be used if you want to show the alphabet keyboard mode.

Parameters

  [in] | obj | The object.
  [in] | lang | Language to be set to the input panel.

Referenced by elm_entry_input_panel_language_set().

## elm_obj_entry_input_panel_language_get()

EOAPI Elm_Input_Panel_Lang elm_obj_entry_input_panel_language_get | ( | const Eo * | obj | ) |

Get the language mode of the input panel.

Parameters

  [in] | obj | The object.

Returns
  Language to be set to the input panel.

Referenced by elm_entry_input_panel_language_get().

## elm_obj_entry_selection_handler_disabled_set()

EOAPI void elm_obj_entry_selection_handler_disabled_set | ( | Eo * | obj,
|  | Eina_Bool | disabled )

This disabled the entry's selection handlers.

Parameters

  [in] | obj | The object.
  [in] | disabled | If `true`, the selection handlers are disabled.

Referenced by elm_entry_selection_handler_disabled_set().

## elm_obj_entry_selection_handler_disabled_get()

EOAPI Eina_Bool elm_obj_entry_selection_handler_disabled_get | ( | const Eo * | obj | ) |

This returns whether the entry's selection handlers are disabled.

Parameters

  [in] | obj | The object.

Returns
  If `true`, the selection handlers are disabled.

## elm_obj_entry_input_panel_layout_variation_set()

EOAPI void elm_obj_entry_input_panel_layout_variation_set | ( | Eo * | obj,
|  | int | variation )

Set the input panel layout variation of the entry.

Parameters

  [in] | obj | The object.
  [in] | variation | Layout variation type.

Since
  1.8

Referenced by elm_entry_input_panel_layout_variation_set().

## elm_obj_entry_input_panel_layout_variation_get()

EOAPI int elm_obj_entry_input_panel_layout_variation_get | ( | const Eo * | obj | ) |

Get the input panel layout variation of the entry.

Parameters

  [in] | obj | The object.

Returns
  Layout variation type.

Since
  1.8

Referenced by elm_entry_input_panel_layout_variation_get().

## elm_obj_entry_autocapital_type_set()

EOAPI void elm_obj_entry_autocapital_type_set | ( | Eo * | obj,
|  | Elm_Autocapital_Type | autocapital_type )

Set the autocapitalization type on the immodule.

Parameters

  [in] | obj | The object.
  [in] | autocapital_type | The type of autocapitalization.

Referenced by elm_entry_autocapital_type_set().

## elm_obj_entry_autocapital_type_get()

EOAPI Elm_Autocapital_Type elm_obj_entry_autocapital_type_get | ( | const Eo * | obj | ) |

Get the autocapitalization type on the immodule.

Parameters

  [in] | obj | The object.

Returns
  The type of autocapitalization.

Referenced by elm_entry_autocapital_type_get().

## elm_obj_entry_editable_set()

EOAPI void elm_obj_entry_editable_set | ( | Eo * | obj,
|  | Eina_Bool | editable )

Sets if the entry is to be editable or not.

By default, entries are editable and when focused, any text input by the user will be inserted at the current cursor position. But calling this function with `editable` as `false` will prevent the user from inputting text into the entry.

The only way to change the text of a non-editable entry is to use elm_object_text_set, elm_entry_entry_insert and other related functions.

Parameters

  [in] | obj | The object.
  [in] | editable | If `true`, user input will be inserted in the entry, if not, the entry is read-only and no user input is allowed.

Referenced by elm_entry_editable_set().

## elm_obj_entry_editable_get()

EOAPI Eina_Bool elm_obj_entry_editable_get | ( | const Eo * | obj | ) |

Get whether the entry is editable or not.

Parameters

  [in] | obj | The object.

Returns
  If `true`, user input will be inserted in the entry, if not, the entry is read-only and no user input is allowed.

Referenced by elm_entry_editable_get().

## elm_obj_entry_anchor_hover_style_set()

EOAPI void elm_obj_entry_anchor_hover_style_set | ( | Eo * | obj,
|  | const char * | style )

Set the style that the hover should use.

When creating the popup hover, entry will request that it's themed according to `style`.

Setting style no `null` means disabling automatic hover.

Parameters

  [in] | obj | The object.
  [in] | style | The style to use for the underlying hover.

Referenced by elm_entry_anchor_hover_style_set().

## elm_obj_entry_anchor_hover_style_get()

EOAPI const char * elm_obj_entry_anchor_hover_style_get | ( | const Eo * | obj | ) |

Get the style that the hover should use.

Parameters

  [in] | obj | The object.

Returns
  The style to use for the underlying hover.

Referenced by elm_entry_anchor_hover_style_get().

## elm_obj_entry_single_line_set()

EOAPI void elm_obj_entry_single_line_set | ( | Eo * | obj,
|  | Eina_Bool | single_line )

Sets the entry to single line mode.

In single line mode, entries don't ever wrap when the text reaches the edge, and instead they keep growing horizontally. Pressing the `Enter` key will generate an $"activate" event instead of adding a new line.

When `single_line` is `false`, line wrapping takes effect again and pressing enter will break the text into a different line without generating any events.

Parameters

  [in] | obj | The object.
  [in] | single_line | If `true`, the text in the entry will be on a single line.

Referenced by elm_entry_single_line_set().

## elm_obj_entry_single_line_get()

EOAPI Eina_Bool elm_obj_entry_single_line_get | ( | const Eo * | obj | ) |

Get whether the entry is set to be single line.

Parameters

  [in] | obj | The object.

Returns
  If `true`, the text in the entry will be on a single line.

Referenced by elm_entry_single_line_get().

## elm_obj_entry_password_set()

EOAPI void elm_obj_entry_password_set | ( | Eo * | obj,
|  | Eina_Bool | password )

Sets the entry to password mode.

In password mode, entries are implicitly single line and the display of any text in them is replaced with asterisks (*).

Parameters

  [in] | obj | The object.
  [in] | password | If `true`, password mode is enabled.

Referenced by elm_entry_password_set().

## elm_obj_entry_password_get()

EOAPI Eina_Bool elm_obj_entry_password_get | ( | const Eo * | obj | ) |

Get whether the entry is set to password mode.

Parameters

  [in] | obj | The object.

Returns
  If `true`, password mode is enabled.

Referenced by elm_entry_password_get().

## elm_obj_entry_input_panel_return_key_disabled_set()

EOAPI void elm_obj_entry_input_panel_return_key_disabled_set | ( | Eo * | obj,
|  | Eina_Bool | disabled )

Set the return key on the input panel to be disabled.

Parameters

  [in] | obj | The object.
  [in] | disabled | The state to put in in: `true` for disabled, `false` for enabled.

Referenced by elm_entry_input_panel_return_key_disabled_set().

## elm_obj_entry_input_panel_return_key_disabled_get()

EOAPI Eina_Bool elm_obj_entry_input_panel_return_key_disabled_get | ( | const Eo * | obj | ) |

Get whether the return key on the input panel should be disabled or not.

Parameters

  [in] | obj | The object.

Returns
  The state to put in in: `true` for disabled, `false` for enabled.

Referenced by elm_entry_input_panel_return_key_disabled_get().

## elm_obj_entry_autosave_set()

EOAPI void elm_obj_entry_autosave_set | ( | Eo * | obj,
|  | Eina_Bool | auto_save )

This sets the entry object to 'autosave' the loaded text file or not.

Parameters

  [in] | obj | The object.
  [in] | auto_save | Autosave the loaded file or not.

Referenced by elm_entry_autosave_set().

## elm_obj_entry_autosave_get()

EOAPI Eina_Bool elm_obj_entry_autosave_get | ( | const Eo * | obj | ) |

This gets the entry object's 'autosave' status.

Parameters

  [in] | obj | The object.

Returns
  Autosave the loaded file or not.

Referenced by elm_entry_autosave_get().

## elm_obj_entry_anchor_hover_parent_set()

EOAPI void elm_obj_entry_anchor_hover_parent_set | ( | Eo * | obj,
|  | Efl_Canvas_Object * | parent )

Set the parent of the hover popup.

Sets the parent object to use by the hover created by the entry when an anchor is clicked.

Parameters

  [in] | obj | The object.
  [in] | parent | The object to use as parent for the hover.

Referenced by elm_entry_anchor_hover_parent_set().

## elm_obj_entry_anchor_hover_parent_get()

EOAPI Efl_Canvas_Object * elm_obj_entry_anchor_hover_parent_get | ( | const Eo * | obj | ) |

Get the parent of the hover popup.

Get the object used as parent for the hover created by the entry widget. If no parent is set, the same entry object will be used.

Parameters

  [in] | obj | The object.

Returns
  The object to use as parent for the hover.

Referenced by elm_entry_anchor_hover_parent_get().

## elm_obj_entry_prediction_allow_set()

EOAPI void elm_obj_entry_prediction_allow_set | ( | Eo * | obj,
|  | Eina_Bool | prediction )

Set whether the entry should allow to use the text prediction.

Parameters

  [in] | obj | The object.
  [in] | prediction | Whether the entry should allow to use the text prediction.

Referenced by elm_entry_prediction_allow_set().

## elm_obj_entry_prediction_allow_get()

EOAPI Eina_Bool elm_obj_entry_prediction_allow_get | ( | const Eo * | obj | ) |

Get whether the entry should allow to use the text prediction.

Parameters

  [in] | obj | The object.

Returns
  Whether the entry should allow to use the text prediction.

Referenced by elm_entry_prediction_allow_get().

## elm_obj_entry_input_hint_set()

EOAPI void elm_obj_entry_input_hint_set | ( | Eo * | obj,
|  | Elm_Input_Hints | hints )

Sets the input hint which allows input methods to fine-tune their behavior.

Parameters

  [in] | obj | The object.
  [in] | hints | Input hint.

Referenced by elm_entry_input_hint_set().

## elm_obj_entry_input_hint_get()

EOAPI Elm_Input_Hints elm_obj_entry_input_hint_get | ( | const Eo * | obj | ) |

Gets the value of input hint.

Parameters

  [in] | obj | The object.

Returns
  Input hint.

Referenced by elm_entry_input_hint_get().

## elm_obj_entry_input_panel_layout_set()

EOAPI void elm_obj_entry_input_panel_layout_set | ( | Eo * | obj,
|  | Elm_Input_Panel_Layout | layout )

Set the input panel layout of the entry.

Parameters

  [in] | obj | The object.
  [in] | layout | Layout type.

Referenced by elm_entry_input_panel_layout_set().

## elm_obj_entry_input_panel_layout_get()

EOAPI Elm_Input_Panel_Layout elm_obj_entry_input_panel_layout_get | ( | const Eo * | obj | ) |

Get the input panel layout of the entry.

Parameters

  [in] | obj | The object.

Returns
  Layout type.

Referenced by elm_entry_input_panel_layout_get().

## elm_obj_entry_input_panel_return_key_type_set()

EOAPI void elm_obj_entry_input_panel_return_key_type_set | ( | Eo * | obj,
|  | Elm_Input_Panel_Return_Key_Type | return_key_type )

Set the "return" key type.

This type is used to set string or icon on the "return" key of the input panel.

An input panel displays the string or icon associated with this type.

Regardless of return key type, "activated" event will be generated when pressing return key in single line entry.

Parameters

  [in] | obj | The object.
  [in] | return_key_type | The type of "return" key on the input panel.

Referenced by elm_entry_input_panel_return_key_type_set().

## elm_obj_entry_input_panel_return_key_type_get()

EOAPI Elm_Input_Panel_Return_Key_Type elm_obj_entry_input_panel_return_key_type_get | ( | const Eo * | obj | ) |

Get the "return" key type.

Parameters

  [in] | obj | The object.

Returns
  The type of "return" key on the input panel.

Referenced by elm_entry_input_panel_return_key_type_get().

## elm_obj_entry_input_panel_enabled_set()

EOAPI void elm_obj_entry_input_panel_enabled_set | ( | Eo * | obj,
|  | Eina_Bool | enabled )

Sets the attribute to show the input panel automatically.

Parameters

  [in] | obj | The object.
  [in] | enabled | If `true`, the input panel is appeared when entry is clicked or has a focus.

Referenced by elm_entry_input_panel_enabled_set().

## elm_obj_entry_input_panel_enabled_get()

EOAPI Eina_Bool elm_obj_entry_input_panel_enabled_get | ( | const Eo * | obj | ) |

Get the attribute to show the input panel automatically.

Parameters

  [in] | obj | The object.

Returns
  If `true`, the input panel is appeared when entry is clicked or has a focus.

Referenced by elm_entry_input_panel_enabled_get().

## elm_obj_entry_line_wrap_set()

EOAPI void elm_obj_entry_line_wrap_set | ( | Eo * | obj,
|  | Elm_Wrap_Type | wrap )

Set the line wrap type to use on multi-line entries.

Sets the wrap type used by the entry to any of the specified in Elm_Wrap_Type. This tells how the text will be implicitly cut into a new line (without inserting a line break or paragraph separator) when it reaches the far edge of the widget.

Note that this only makes sense for multi-line entries. A widget set to be single line will never wrap.

Parameters

  [in] | obj | The object.
  [in] | wrap | The wrap mode to use. See Elm_Wrap_Type for details on them.

Referenced by elm_entry_line_wrap_set().

## elm_obj_entry_line_wrap_get()

EOAPI Elm_Wrap_Type elm_obj_entry_line_wrap_get | ( | const Eo * | obj | ) |

Get the wrap mode the entry was set to use.

Parameters

  [in] | obj | The object.

Returns
  The wrap mode to use. See Elm_Wrap_Type for details on them.

Referenced by elm_entry_line_wrap_get().

## elm_obj_entry_cursor_pos_set()

EOAPI void elm_obj_entry_cursor_pos_set | ( | Eo * | obj,
|  | int | pos )

Sets the cursor position in the entry to the given value.

The value in `pos` is the index of the character position within the contents of the string as returned by elm_obj_entry_cursor_pos_get.

Parameters

  [in] | obj | The object.
  [in] | pos | The position of the cursor.

Referenced by elm_entry_cursor_pos_set().

## elm_obj_entry_cursor_pos_get()

EOAPI int elm_obj_entry_cursor_pos_get | ( | const Eo * | obj | ) |

Get the current position of the cursor in the entry.

Parameters

  [in] | obj | The object.

Returns
  The position of the cursor.

Referenced by elm_entry_cursor_pos_get().

## elm_obj_entry_icon_visible_set()

EOAPI void elm_obj_entry_icon_visible_set | ( | Eo * | obj,
|  | Eina_Bool | setting )

Sets the visibility of the left-side widget of the entry, set by elm_object_part_content_set.

Parameters

  [in] | obj | The object.
  [in] | setting | `true` if the object should be displayed, `false` if not.

Referenced by elm_entry_icon_visible_set().

## elm_obj_entry_select_region_set()

EOAPI void elm_obj_entry_select_region_set | ( | Eo * | obj,
|  | int | start,
|  | int | end )

This selects a region of text within the entry.

Parameters

  [in] | obj | The object.
  [in] | start | The starting position.
  [in] | end | The end position.

Since
  1.9

Referenced by elm_entry_select_region_set().

## elm_obj_entry_select_region_get()

EOAPI void elm_obj_entry_select_region_get | ( | const Eo * | obj,
|  | int * | start,
|  | int * | end )

Get the current position of the selection cursors in the entry.

Parameters

  [in] | obj | The object.
  [out] | start | The starting position.
  [out] | end | The end position.

Since
  1.18

Referenced by elm_entry_select_region_get().

## elm_obj_entry_input_panel_return_key_autoenabled_set()

EOAPI void elm_obj_entry_input_panel_return_key_autoenabled_set | ( | Eo * | obj,
|  | Eina_Bool | enabled )

Set whether the return key on the input panel is disabled automatically when entry has no text.

If `enabled` is `true`, The return key on input panel is disabled when the entry has no text. The return key on the input panel is automatically enabled when the entry has text. The default value is `false`.

Parameters

  [in] | obj | The object.
  [in] | enabled | If `enabled` is `true`, the return key is automatically disabled when the entry has no text.

Referenced by elm_entry_input_panel_return_key_autoenabled_set().

## elm_obj_entry_end_visible_set()

EOAPI void elm_obj_entry_end_visible_set | ( | Eo * | obj,
|  | Eina_Bool | setting )

Sets the visibility of the end widget of the entry, set by elm_object_part_content_set(ent, "end", content).

Parameters

  [in] | obj | The object.
  [in] | setting | `true` if the object should be displayed, false if not.

Referenced by elm_entry_end_visible_set().

## elm_obj_entry_textblock_get()

EOAPI Efl_Canvas_Object * elm_obj_entry_textblock_get | ( | const Eo * | obj | ) |

Returns the actual textblock object of the entry.

This function exposes the internal textblock object that actually contains and draws the text. This should be used for low-level manipulations that are otherwise not possible.

Changing the textblock directly from here will not notify edje/elm to recalculate the textblock size automatically, so any modifications done to the textblock returned by this function should be followed by a call to elm_entry_calc_force.

The return value is marked as const as an additional warning. One should not use the returned object with any of the generic evas functions (geometry_get/resize/move and etc), but only with the textblock functions; The former will either not work at all, or break the correct functionality.

IMPORTANT: Many functions may change (i.e delete and create a new one) the internal textblock object. Do NOT cache the returned object, and try not to mix calls on this object with regular elm_entry calls (which may change the internal textblock object). This applies to all cursors returned from textblock calls, and all the other derivative values.

Parameters

  [in] | obj | The object.

Returns
  Textblock object

Referenced by elm_entry_textblock_get().

## elm_obj_entry_textblock_cursor_geometry_get()

EOAPI Eina_Bool elm_obj_entry_textblock_cursor_geometry_get | ( | const Eo * | obj,
|  | int * | x,
|  | int * | y,
|  | int * | w,
|  | int * | h )

This function returns the geometry of the cursor.

It's useful if you want to draw something on the cursor (or where it is), or for example in the case of scrolled entry where you want to show the cursor.

Parameters

  [in] | obj | The object.
  [out] | x | X coordinate
  [out] | y | Y coordinate
  [out] | w | Width
  [out] | h | Height

Returns
  `true` on success, `false` otherwise

Referenced by elm_entry_cursor_geometry_get().

## elm_obj_entry_imf_context_get()

EOAPI void * elm_obj_entry_imf_context_get | ( | const Eo * | obj | ) |

Returns the input method context of the entry.

This function exposes the internal input method context.

IMPORTANT: Many functions may change (i.e delete and create a new one) the internal input method context. Do NOT cache the returned object.

Parameters

  [in] | obj | The object.

Returns
  Input method context

Referenced by elm_entry_imf_context_get().

## elm_obj_entry_cursor_is_format_get()

EOAPI Eina_Bool elm_obj_entry_cursor_is_format_get | ( | const Eo * | obj | ) |

Get whether a format node exists at the current cursor position.

A format node is anything that defines how the text is rendered. It can be a visible format node, such as a line break or a paragraph separator, or an invisible one, such as bold begin or end tag. This function returns whether any format node exists at the current cursor position.

Parameters

  [in] | obj | The object.

Returns
  `true` if format node exists, `false` otherwise

Referenced by elm_entry_cursor_is_format_get().

## elm_obj_entry_textblock_cursor_content_get()

EOAPI char * elm_obj_entry_textblock_cursor_content_get | ( | const Eo * | obj | ) |

Get the character pointed by the cursor at its current position.

This function returns a string with the utf8 character stored at the current cursor position. Only the text is returned, any format that may exist will not be part of the return value. You must free the string when done with free.

Parameters

  [in] | obj | The object.

Returns
  Character

References EINA_WARN_UNUSED_RESULT.

Referenced by elm_entry_cursor_content_get().

## elm_obj_entry_selection_get()

EOAPI const char * elm_obj_entry_selection_get | ( | const Eo * | obj | ) |

Get any selected text within the entry.

If there's any selected text in the entry, this function returns it as a string in markup format. `null` is returned if no selection exists or if an error occurred.

The returned value points to an internal string and should not be freed or modified in any way. If the `entry` object is deleted or its contents are changed, the returned pointer should be considered invalid.

Parameters

  [in] | obj | The object.

Returns
  Selected string

Referenced by elm_entry_selection_get().

## elm_obj_entry_cursor_is_visible_format_get()

EOAPI Eina_Bool elm_obj_entry_cursor_is_visible_format_get | ( | const Eo * | obj | ) |

Get if the current cursor position holds a visible format node.

Parameters

  [in] | obj | The object.

Returns
  `true` if position has a visible format, `false` otherwise

Referenced by elm_entry_cursor_is_visible_format_get().

## elm_obj_entry_select_allow_set()

EOAPI void elm_obj_entry_select_allow_set | ( | Eo * | obj,
|  | Eina_Bool | allow )

Allow selection in the entry.

Parameters

  [in] | obj | The object.
  [in] | allow | If `allow` is true, the text selection is allowed.

Since
  1.18

Referenced by elm_entry_select_allow_set().

## elm_obj_entry_select_allow_get()

EOAPI Eina_Bool elm_obj_entry_select_allow_get | ( | const Eo * | obj | ) |

Allow selection in the entry.

Parameters

  [in] | obj | The object.

Returns
  If `allow` is true, the text selection is allowed.

Since
  1.18

Referenced by elm_entry_select_allow_get().

## elm_obj_entry_cursor_prev()

EOAPI Eina_Bool elm_obj_entry_cursor_prev | ( | Eo * | obj | ) |

This moves the cursor one place to the left within the entry.

Parameters

  [in] | obj | The object.

Returns
  `true` on success, `false` otherwise

Referenced by elm_entry_cursor_prev().

## elm_obj_entry_text_style_user_pop()

EOAPI void elm_obj_entry_text_style_user_pop | ( | Eo * | obj | ) |

Remove the style in the top of user style stack.

Since
  1.7

Referenced by elm_entry_text_style_user_pop().

## elm_obj_entry_item_provider_prepend()

EOAPI void elm_obj_entry_item_provider_prepend | ( | Eo * | obj,
|  | Elm_Entry_Item_Provider_Cb | func,
|  | void * | data )

This prepends a custom item provider to the list for that entry.

This prepends the given callback.

Parameters

  [in] | obj | The object.
  [in] | func | The function called to provide the item object.
  [in] | data | The data passed to `func`.

Referenced by elm_entry_item_provider_prepend().

## elm_obj_entry_input_panel_show()

EOAPI void elm_obj_entry_input_panel_show | ( | Eo * | obj | ) |

Show the input panel (virtual keyboard) based on the input panel property of entry such as layout, autocapital types, and so on.

Note that input panel is shown or hidden automatically according to the focus state of entry widget. This API can be used in the case of manually controlling by using elm_obj_entry_input_panel_enabled_set(en, `false`).

Parameters

  [in] | obj | The object.

Referenced by elm_entry_input_panel_show().

## elm_obj_entry_imf_context_reset()

EOAPI void elm_obj_entry_imf_context_reset | ( | Eo * | obj | ) |

Reset the input method context of the entry if needed.

This can be necessary in the case where modifying the buffer would confuse on-going input method behavior. This will typically cause the Input Method Context to clear the preedit state.

Parameters

  [in] | obj | The object.

Referenced by elm_entry_imf_context_reset().

## elm_obj_entry_anchor_hover_end()

EOAPI void elm_obj_entry_anchor_hover_end | ( | Eo * | obj | ) |

Ends the hover popup in the entry.

When an anchor is clicked, the entry widget will create a hover object to use as a popup with user provided content. This function terminates this popup, returning the entry to its normal state.

Parameters

  [in] | obj | The object.

Referenced by elm_entry_anchor_hover_end().

## elm_obj_entry_cursor_down()

EOAPI Eina_Bool elm_obj_entry_cursor_down | ( | Eo * | obj | ) |

This moves the cursor one line down within the entry.

Parameters

  [in] | obj | The object.

Returns
  `true` on success, `false` otherwise

Referenced by elm_entry_cursor_down().

## elm_obj_entry_text_style_user_push()

EOAPI void elm_obj_entry_text_style_user_push | ( | Eo * | obj,
|  | const char * | style )

Push the style to the top of user style stack.

If there is styles in the user style stack, the properties in the top style of user style stack will replace the properties in current theme. The input style is specified in format tag='property=value' (i.e. DEFAULT='font=Sans font_size=60'hilight=' + font_weight=Bold').

Parameters

  [in] | obj | The object.
  [in] | style | The style user to push.

Since
  1.7

Referenced by elm_entry_text_style_user_push().

## elm_obj_entry_item_provider_remove()

EOAPI void elm_obj_entry_item_provider_remove | ( | Eo * | obj,
|  | Elm_Entry_Item_Provider_Cb | func,
|  | void * | data )

This removes a custom item provider to the list for that entry.

This removes the given callback. See elm_obj_entry_item_provider_append for more information

Parameters

  [in] | obj | The object.
  [in] | func | The function called to provide the item object.
  [in] | data | The data passed to `func`.

Referenced by elm_entry_item_provider_remove().

## elm_obj_entry_text_style_user_peek()

EOAPI const char * elm_obj_entry_text_style_user_peek | ( | const Eo * | obj | ) |

Get the style on the top of user style stack.

See also elm_obj_entry_text_style_user_push.

Parameters

  [in] | obj | The object.

Returns
  Style

Since
  1.7

Referenced by elm_entry_text_style_user_peek().

## elm_obj_entry_context_menu_clear()

EOAPI void elm_obj_entry_context_menu_clear | ( | Eo * | obj | ) |

This clears and frees the items in a entry's contextual (longpress) menu.

See also elm_obj_entry_context_menu_item_add.

Parameters

  [in] | obj | The object.

Referenced by elm_entry_context_menu_clear().

## elm_obj_entry_cursor_up()

EOAPI Eina_Bool elm_obj_entry_cursor_up | ( | Eo * | obj | ) |

This moves the cursor one line up within the entry.

Parameters

  [in] | obj | The object.

Returns
  `true` on success, `false` otherwise

Referenced by elm_entry_cursor_up().

## elm_obj_entry_insert()

EOAPI void elm_obj_entry_insert | ( | Eo * | obj,
|  | const char * | entry )

Inserts the given text into the entry at the current cursor position.

This inserts text at the cursor position as if it was typed by the user (note that this also allows markup which a user can't just "type" as it would be converted to escaped text, so this call can be used to insert things like emoticon items or bold push/pop tags, other font and color change tags etc.)

If any selection exists, it will be replaced by the inserted text.

The inserted text is subject to any filters set for the widget.

See also elm_obj_entry_markup_filter_append.

Parameters

  [in] | obj | The object.
  [in] | entry | The text to insert.

Referenced by elm_entry_entry_insert().

## elm_obj_entry_input_panel_imdata_set()

EOAPI void elm_obj_entry_input_panel_imdata_set | ( | Eo * | obj,
|  | const void * | data,
|  | int | len )

Set the input panel-specific data to deliver to the input panel.

This API is used by applications to deliver specific data to the input panel. The data format MUST be negotiated by both application and the input panel. The size and format of data are defined by the input panel.

Parameters

  [in] | obj | The object.
  [in] | data | The specific data to be set to the input panel.
  [in] | len | The length of data, in bytes, to send to the input panel.

Referenced by elm_entry_input_panel_imdata_set().

## elm_obj_entry_input_panel_imdata_get()

EOAPI void elm_obj_entry_input_panel_imdata_get | ( | const Eo * | obj,
|  | void * | data,
|  | int * | len )

Get the specific data of the current input panel.

Parameters

  [in] | obj | The object.
  [out] | data | The specific data to be got from the input panel.
  [out] | len | The length of data.

Referenced by elm_entry_input_panel_imdata_get().

## elm_obj_entry_cursor_next()

EOAPI Eina_Bool elm_obj_entry_cursor_next | ( | Eo * | obj | ) |

This moves the cursor one place to the right within the entry.

Parameters

  [in] | obj | The object.

Returns
  `true` on success, `false` otherwise

Referenced by elm_entry_cursor_next().

## elm_obj_entry_input_panel_hide()

EOAPI void elm_obj_entry_input_panel_hide | ( | Eo * | obj | ) |

Hide the input panel (virtual keyboard).

Note that input panel is shown or hidden automatically according to the focus state of entry widget. This API can be used in the case of manually controlling by using elm_obj_entry_input_panel_enabled_set(en, `false`)

Parameters

  [in] | obj | The object.

Referenced by elm_entry_input_panel_hide().

## elm_obj_entry_is_empty()

EOAPI Eina_Bool elm_obj_entry_is_empty | ( | const Eo * | obj | ) |

Get whether the entry is empty.

Empty means no text at all. If there are any markup tags, like an item tag for which no provider finds anything, and no text is displayed, this function still returns `false`.

Parameters

  [in] | obj | The object.

Returns
  `true` if empty, `false` otherwise

Referenced by elm_entry_is_empty().

## elm_obj_entry_markup_filter_remove()

EOAPI void elm_obj_entry_markup_filter_remove | ( | Eo * | obj,
|  | Elm_Entry_Filter_Cb | func,
|  | void * | data )

Remove a markup filter from the list.

Removes the given callback from the filter list. See elm_obj_entry_markup_filter_append for more information.

Parameters

  [in] | obj | The object.
  [in] | func | The filter function to remove.
  [in] | data | The user data passed when adding the function.

Referenced by elm_entry_markup_filter_remove().

## elm_obj_entry_item_provider_append()

EOAPI void elm_obj_entry_item_provider_append | ( | Eo * | obj,
|  | Elm_Entry_Item_Provider_Cb | func,
|  | void * | data )

This appends a custom item provider to the list for that entry.

This appends the given callback. The list is walked from beginning to end with each function called given the item href string in the text. If the function returns an object handle other than `null` (it should create an object to do this), then this object is used to replace that item. If not the next provider is called until one provides an item object, or the default provider in entry does.

See also Items.

Parameters

  [in] | obj | The object.
  [in] | func | The function called to provide the item object.
  [in] | data | The data passed to `func`.

Referenced by elm_entry_item_provider_append().

## elm_obj_entry_markup_filter_append()

EOAPI void elm_obj_entry_markup_filter_append | ( | Eo * | obj,
|  | Elm_Entry_Filter_Cb | func,
|  | void * | data )

Append a markup filter function for text inserted in the entry.

Append the given callback to the list. This functions will be called whenever any text is inserted into the entry, with the text to be inserted as a parameter. The type of given text is always markup. The callback function is free to alter the text in any way it wants, but it must remember to free the given pointer and update it. If the new text is to be discarded, the function can free it and set its text parameter to `null`. This will also prevent any following filters from being called.

Parameters

  [in] | obj | The object.
  [in] | func | The function to use as text filter.
  [in] | data | User data to pass to `func`.

Referenced by elm_entry_markup_filter_append().

## elm_obj_entry_append()

EOAPI void elm_obj_entry_append | ( | Eo * | obj,
|  | const char * | str )

Appends `str` to the text of the entry.

Adds the text in `str` to the end of any text already present in the widget.

The appended text is subject to any filters set for the widget.

See also elm_obj_entry_markup_filter_append.

Parameters

  [in] | obj | The object.
  [in] | str | The text to be appended.

Referenced by elm_entry_entry_append().

## elm_obj_entry_context_menu_item_add()

EOAPI void elm_obj_entry_context_menu_item_add | ( | Eo * | obj,
|  | const char * | label,
|  | const char * | icon_file,
|  | Elm_Icon_Type | icon_type,
|  | Evas_Smart_Cb | func,
|  | const void * | data )

This adds an item to the entry's contextual menu.

A longpress on an entry will make the contextual menu show up, if this hasn't been disabled with elm_obj_entry_context_menu_disabled_set. By default, this menu provides a few options like enabling selection mode, which is useful on embedded devices that need to be explicit about it, and when a selection exists it also shows the copy and cut actions.

With this function, developers can add other options to this menu to perform any action they deem necessary.

Parameters

  [in] | obj | The object.
  [in] | label | The item's text label.
  [in] | icon_file | The item's icon file.
  [in] | icon_type | The item's icon type.
  [in] | func | The callback to execute when the item is clicked.
  [in] | data | The data to associate with the item for related functions.

Referenced by elm_entry_context_menu_item_add().

## elm_obj_entry_markup_filter_prepend()

EOAPI void elm_obj_entry_markup_filter_prepend | ( | Eo * | obj,
|  | Elm_Entry_Filter_Cb | func,
|  | void * | data )

Prepend a markup filter function for text inserted in the entry.

Prepend the given callback to the list.

Parameters

  [in] | obj | The object.
  [in] | func | The function to use as text filter.
  [in] | data | User data to pass to `func`.

Referenced by elm_entry_markup_filter_prepend().

## elm_obj_entry_prediction_hint_set()

EOAPI void elm_obj_entry_prediction_hint_set | ( | Eo * | obj,
|  | const char * | prediction_hint )

Sets the prediction hint to use an intelligent reply suggestion service.

Parameters

  [in] | obj | The object.
  [in] | prediction_hint | The prediction hint text.

Since
  1.20

Referenced by elm_entry_prediction_hint_set().

## elm_obj_entry_prediction_hint_hash_set()

EOAPI Eina_Bool elm_obj_entry_prediction_hint_hash_set | ( | Eo * | obj,
|  | const char * | key,
|  | const char * | value )

Sets the prediction hint data at the specified key.

Parameters

  [in] | obj | The object.
  [in] | key | The key of the prediction hint.
  [in] | value | The data to replace.

Returns
  `true` on success, `false` otherwise

Since
  1.21

Referenced by elm_entry_prediction_hint_hash_set().

## elm_obj_entry_prediction_hint_hash_del()

EOAPI Eina_Bool elm_obj_entry_prediction_hint_hash_del | ( | Eo * | obj,
|  | const char * | key )

Removes the prediction hint data identified by a key.

Parameters

  [in] | obj | The object.
  [in] | key | The key of the prediction hint.

Returns
  `true` on success, `false` otherwise

Since
  1.21

Referenced by elm_entry_prediction_hint_hash_del().

## elm_entry_scrollable_set()

void elm_entry_scrollable_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | scroll )

Enable or disable scrolling in entry.

Normally the entry is not scrollable unless you enable it with this call.

Parameters

  [in] | obj | The object.
  [in] | scroll | `true` if it is to be scrollable, `false` otherwise.

References elm_obj_entry_scrollable_set().

## elm_entry_scrollable_get()

Eina_Bool elm_entry_scrollable_get | ( | const Elm_Entry * | obj | ) |

Get the scrollable state of the entry.

Normally the entry is not scrollable. This gets the scrollable state of the entry.

Parameters

  [in] | obj | The object.

Returns
  `true` if it is to be scrollable, `false` otherwise.

References elm_obj_entry_scrollable_get().

## elm_entry_input_panel_show_on_demand_set()

void elm_entry_input_panel_show_on_demand_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | ondemand )

Set the attribute to show the input panel in case of only a user's explicit Mouse Up event.

It doesn't request to show the input panel even though it has focus.

Parameters

  [in] | obj | The object.
  [in] | ondemand | If `true`, the input panel will be shown in case of only Mouse up event. (Focus event will be ignored.)

Since
  1.9

References elm_obj_entry_input_panel_show_on_demand_set().

## elm_entry_input_panel_show_on_demand_get()

Eina_Bool elm_entry_input_panel_show_on_demand_get | ( | const Elm_Entry * | obj | ) |

Get the attribute to show the input panel in case of only a user's explicit Mouse Up event.

Parameters

  [in] | obj | The object.

Returns
  If `true`, the input panel will be shown in case of only Mouse up event. (Focus event will be ignored.)

Since
  1.9

References elm_obj_entry_input_panel_show_on_demand_get().

## elm_entry_context_menu_disabled_set()

void elm_entry_context_menu_disabled_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | disabled )

This disables the entry's contextual (longpress) menu.

Parameters

  [in] | obj | The object.
  [in] | disabled | If `true`, the menu is disabled.

References elm_obj_entry_context_menu_disabled_set().

## elm_entry_context_menu_disabled_get()

Eina_Bool elm_entry_context_menu_disabled_get | ( | const Elm_Entry * | obj | ) |

This returns whether the entry's contextual (longpress) menu is disabled.

Parameters

  [in] | obj | The object.

Returns
  If `true`, the menu is disabled.

References elm_obj_entry_context_menu_disabled_get().

## elm_entry_cnp_mode_set()

void elm_entry_cnp_mode_set | ( | Elm_Entry * | obj,
|  | Elm_Cnp_Mode | cnp_mode )

Control pasting of text and images for the widget.

Normally the entry allows both text and images to be pasted. By setting cnp_mode to be ELM_CNP_MODE_NO_IMAGE, this prevents images from being copy or past. By setting cnp_mode to be ELM_CNP_MODE_PLAINTEXT, this remove all tags in text .

Note
  This only changes the behaviour of text.

Parameters

  [in] | obj | The object.
  [in] | cnp_mode | One of Elm_Cnp_Mode: ELM_CNP_MODE_MARKUP, ELM_CNP_MODE_NO_IMAGE, ELM_CNP_MODE_PLAINTEXT.

References elm_obj_entry_cnp_mode_set().

Referenced by elm_scrolled_entry_cnp_textonly_set().

## elm_entry_cnp_mode_get()

Elm_Cnp_Mode elm_entry_cnp_mode_get | ( | const Elm_Entry * | obj | ) |

Getting elm_entry text paste/drop mode.

Normally the entry allows both text and images to be pasted. This gets the copy & paste mode of the entry.

Parameters

  [in] | obj | The object.

Returns
  One of Elm_Cnp_Mode: ELM_CNP_MODE_MARKUP, ELM_CNP_MODE_NO_IMAGE, ELM_CNP_MODE_PLAINTEXT.

References elm_obj_entry_cnp_mode_get().

Referenced by elm_scrolled_entry_cnp_textonly_get().

## elm_entry_file_text_format_set()

void elm_entry_file_text_format_set | ( | Elm_Entry * | obj,
|  | Elm_Text_Format | format )

Text format used to load and save the file, which could be plain text or markup text.

Default is `ELM_TEXT_FORMAT_PLAIN_UTF8`, if you want to use `ELM_TEXT_FORMAT_MARKUP_UTF8` then you need to set the text format before calling Efl.File.load.

You could also set it before a call to elm_entry_file_save in order to save with the given format.

Use it before calling Efl.File.load or elm_entry_file_save.

Parameters

  [in] | obj | The object.
  [in] | format | The file format

References elm_obj_entry_file_text_format_set().

## elm_entry_input_panel_language_set()

void elm_entry_input_panel_language_set | ( | Elm_Entry * | obj,
|  | Elm_Input_Panel_Lang | lang )

Set the language mode of the input panel.

This API can be used if you want to show the alphabet keyboard mode.

Parameters

  [in] | obj | The object.
  [in] | lang | Language to be set to the input panel.

References elm_obj_entry_input_panel_language_set().

## elm_entry_input_panel_language_get()

Elm_Input_Panel_Lang elm_entry_input_panel_language_get | ( | const Elm_Entry * | obj | ) |

Get the language mode of the input panel.

Parameters

  [in] | obj | The object.

Returns
  Language to be set to the input panel.

References elm_obj_entry_input_panel_language_get().

## elm_entry_selection_handler_disabled_set()

void elm_entry_selection_handler_disabled_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | disabled )

This disabled the entry's selection handlers.

Parameters

  [in] | obj | The object.
  [in] | disabled | If `true`, the selection handlers are disabled.

References elm_obj_entry_selection_handler_disabled_set().

## elm_entry_input_panel_layout_variation_set()

void elm_entry_input_panel_layout_variation_set | ( | Elm_Entry * | obj,
|  | int | variation )

Set the input panel layout variation of the entry.

Parameters

  [in] | obj | The object.
  [in] | variation | Layout variation type.

Since
  1.8

References elm_obj_entry_input_panel_layout_variation_set().

## elm_entry_input_panel_layout_variation_get()

int elm_entry_input_panel_layout_variation_get | ( | const Elm_Entry * | obj | ) |

Get the input panel layout variation of the entry.

Parameters

  [in] | obj | The object.

Returns
  Layout variation type.

Since
  1.8

References elm_obj_entry_input_panel_layout_variation_get().

## elm_entry_autocapital_type_set()

void elm_entry_autocapital_type_set | ( | Elm_Entry * | obj,
|  | Elm_Autocapital_Type | autocapital_type )

Set the autocapitalization type on the immodule.

Parameters

  [in] | obj | The object.
  [in] | autocapital_type | The type of autocapitalization.

References elm_obj_entry_autocapital_type_set().

## elm_entry_autocapital_type_get()

Elm_Autocapital_Type elm_entry_autocapital_type_get | ( | const Elm_Entry * | obj | ) |

Get the autocapitalization type on the immodule.

Parameters

  [in] | obj | The object.

Returns
  The type of autocapitalization.

References elm_obj_entry_autocapital_type_get().

## elm_entry_editable_set()

void elm_entry_editable_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | editable )

Sets if the entry is to be editable or not.

By default, entries are editable and when focused, any text input by the user will be inserted at the current cursor position. But calling this function with `editable` as `false` will prevent the user from inputting text into the entry.

The only way to change the text of a non-editable entry is to use elm_object_text_set, elm_entry_entry_insert and other related functions.

Parameters

  [in] | obj | The object.
  [in] | editable | If `true`, user input will be inserted in the entry, if not, the entry is read-only and no user input is allowed.

References elm_obj_entry_editable_set().

## elm_entry_editable_get()

Eina_Bool elm_entry_editable_get | ( | const Elm_Entry * | obj | ) |

Get whether the entry is editable or not.

Parameters

  [in] | obj | The object.

Returns
  If `true`, user input will be inserted in the entry, if not, the entry is read-only and no user input is allowed.

References elm_obj_entry_editable_get().

## elm_entry_anchor_hover_style_set()

void elm_entry_anchor_hover_style_set | ( | Elm_Entry * | obj,
|  | const char * | style )

Set the style that the hover should use.

When creating the popup hover, entry will request that it's themed according to `style`.

Setting style no `null` means disabling automatic hover.

Parameters

  [in] | obj | The object.
  [in] | style | The style to use for the underlying hover.

References elm_obj_entry_anchor_hover_style_set().

## elm_entry_anchor_hover_style_get()

const char * elm_entry_anchor_hover_style_get | ( | const Elm_Entry * | obj | ) |

Get the style that the hover should use.

Parameters

  [in] | obj | The object.

Returns
  The style to use for the underlying hover.

References elm_obj_entry_anchor_hover_style_get().

## elm_entry_single_line_set()

void elm_entry_single_line_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | single_line )

Sets the entry to single line mode.

In single line mode, entries don't ever wrap when the text reaches the edge, and instead they keep growing horizontally. Pressing the `Enter` key will generate an $"activate" event instead of adding a new line.

When `single_line` is `false`, line wrapping takes effect again and pressing enter will break the text into a different line without generating any events.

Parameters

  [in] | obj | The object.
  [in] | single_line | If `true`, the text in the entry will be on a single line.

References elm_obj_entry_single_line_set().

## elm_entry_single_line_get()

Eina_Bool elm_entry_single_line_get | ( | const Elm_Entry * | obj | ) |

Get whether the entry is set to be single line.

Parameters

  [in] | obj | The object.

Returns
  If `true`, the text in the entry will be on a single line.

References elm_obj_entry_single_line_get().

## elm_entry_password_set()

void elm_entry_password_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | password )

Sets the entry to password mode.

In password mode, entries are implicitly single line and the display of any text in them is replaced with asterisks (*).

Parameters

  [in] | obj | The object.
  [in] | password | If `true`, password mode is enabled.

References elm_obj_entry_password_set().

## elm_entry_password_get()

Eina_Bool elm_entry_password_get | ( | const Elm_Entry * | obj | ) |

Get whether the entry is set to password mode.

Parameters

  [in] | obj | The object.

Returns
  If `true`, password mode is enabled.

References elm_obj_entry_password_get().

## elm_entry_input_panel_return_key_disabled_set()

void elm_entry_input_panel_return_key_disabled_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | disabled )

Set the return key on the input panel to be disabled.

Parameters

  [in] | obj | The object.
  [in] | disabled | The state to put in in: `true` for disabled, `false` for enabled.

References elm_obj_entry_input_panel_return_key_disabled_set().

## elm_entry_input_panel_return_key_disabled_get()

Eina_Bool elm_entry_input_panel_return_key_disabled_get | ( | const Elm_Entry * | obj | ) |

Get whether the return key on the input panel should be disabled or not.

Parameters

  [in] | obj | The object.

Returns
  The state to put in in: `true` for disabled, `false` for enabled.

References elm_obj_entry_input_panel_return_key_disabled_get().

## elm_entry_autosave_set()

void elm_entry_autosave_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | auto_save )

This sets the entry object to 'autosave' the loaded text file or not.

Parameters

  [in] | obj | The object.
  [in] | auto_save | Autosave the loaded file or not.

References elm_obj_entry_autosave_set().

## elm_entry_autosave_get()

Eina_Bool elm_entry_autosave_get | ( | const Elm_Entry * | obj | ) |

This gets the entry object's 'autosave' status.

Parameters

  [in] | obj | The object.

Returns
  Autosave the loaded file or not.

References elm_obj_entry_autosave_get().

## elm_entry_anchor_hover_parent_set()

void elm_entry_anchor_hover_parent_set | ( | Elm_Entry * | obj,
|  | Efl_Canvas_Object * | parent )

Set the parent of the hover popup.

Sets the parent object to use by the hover created by the entry when an anchor is clicked.

Parameters

  [in] | obj | The object.
  [in] | parent | The object to use as parent for the hover.

References elm_obj_entry_anchor_hover_parent_set().

## elm_entry_anchor_hover_parent_get()

Efl_Canvas_Object * elm_entry_anchor_hover_parent_get | ( | const Elm_Entry * | obj | ) |

Get the parent of the hover popup.

Get the object used as parent for the hover created by the entry widget. If no parent is set, the same entry object will be used.

Parameters

  [in] | obj | The object.

Returns
  The object to use as parent for the hover.

References elm_obj_entry_anchor_hover_parent_get().

## elm_entry_prediction_allow_set()

void elm_entry_prediction_allow_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | prediction )

Set whether the entry should allow to use the text prediction.

Parameters

  [in] | obj | The object.
  [in] | prediction | Whether the entry should allow to use the text prediction.

References elm_obj_entry_prediction_allow_set().

## elm_entry_prediction_allow_get()

Eina_Bool elm_entry_prediction_allow_get | ( | const Elm_Entry * | obj | ) |

Get whether the entry should allow to use the text prediction.

Parameters

  [in] | obj | The object.

Returns
  Whether the entry should allow to use the text prediction.

References elm_obj_entry_prediction_allow_get().

## elm_entry_input_hint_set()

void elm_entry_input_hint_set | ( | Elm_Entry * | obj,
|  | Elm_Input_Hints | hints )

Sets the input hint which allows input methods to fine-tune their behavior.

Parameters

  [in] | obj | The object.
  [in] | hints | Input hint.

References elm_obj_entry_input_hint_set().

## elm_entry_input_hint_get()

Elm_Input_Hints elm_entry_input_hint_get | ( | const Elm_Entry * | obj | ) |

Gets the value of input hint.

Parameters

  [in] | obj | The object.

Returns
  Input hint.

References elm_obj_entry_input_hint_get().

## elm_entry_input_panel_layout_set()

void elm_entry_input_panel_layout_set | ( | Elm_Entry * | obj,
|  | Elm_Input_Panel_Layout | layout )

Set the input panel layout of the entry.

Parameters

  [in] | obj | The object.
  [in] | layout | Layout type.

References elm_obj_entry_input_panel_layout_set().

## elm_entry_input_panel_layout_get()

Elm_Input_Panel_Layout elm_entry_input_panel_layout_get | ( | const Elm_Entry * | obj | ) |

Get the input panel layout of the entry.

Parameters

  [in] | obj | The object.

Returns
  Layout type.

References elm_obj_entry_input_panel_layout_get().

## elm_entry_input_panel_return_key_type_set()

void elm_entry_input_panel_return_key_type_set | ( | Elm_Entry * | obj,
|  | Elm_Input_Panel_Return_Key_Type | return_key_type )

Set the "return" key type.

This type is used to set string or icon on the "return" key of the input panel.

An input panel displays the string or icon associated with this type.

Regardless of return key type, "activated" event will be generated when pressing return key in single line entry.

Parameters

  [in] | obj | The object.
  [in] | return_key_type | The type of "return" key on the input panel.

References elm_obj_entry_input_panel_return_key_type_set().

## elm_entry_input_panel_return_key_type_get()

Elm_Input_Panel_Return_Key_Type elm_entry_input_panel_return_key_type_get | ( | const Elm_Entry * | obj | ) |

Get the "return" key type.

Parameters

  [in] | obj | The object.

Returns
  The type of "return" key on the input panel.

References elm_obj_entry_input_panel_return_key_type_get().

## elm_entry_input_panel_enabled_set()

void elm_entry_input_panel_enabled_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | enabled )

Sets the attribute to show the input panel automatically.

Parameters

  [in] | obj | The object.
  [in] | enabled | If `true`, the input panel is appeared when entry is clicked or has a focus.

References elm_obj_entry_input_panel_enabled_set().

## elm_entry_input_panel_enabled_get()

Eina_Bool elm_entry_input_panel_enabled_get | ( | const Elm_Entry * | obj | ) |

Get the attribute to show the input panel automatically.

Parameters

  [in] | obj | The object.

Returns
  If `true`, the input panel is appeared when entry is clicked or has a focus.

References elm_obj_entry_input_panel_enabled_get().

## elm_entry_line_wrap_set()

void elm_entry_line_wrap_set | ( | Elm_Entry * | obj,
|  | Elm_Wrap_Type | wrap )

Set the line wrap type to use on multi-line entries.

Sets the wrap type used by the entry to any of the specified in Elm_Wrap_Type. This tells how the text will be implicitly cut into a new line (without inserting a line break or paragraph separator) when it reaches the far edge of the widget.

Note that this only makes sense for multi-line entries. A widget set to be single line will never wrap.

Parameters

  [in] | obj | The object.
  [in] | wrap | The wrap mode to use. See Elm_Wrap_Type for details on them.

References elm_obj_entry_line_wrap_set().

## elm_entry_line_wrap_get()

Elm_Wrap_Type elm_entry_line_wrap_get | ( | const Elm_Entry * | obj | ) |

Get the wrap mode the entry was set to use.

Parameters

  [in] | obj | The object.

Returns
  The wrap mode to use. See Elm_Wrap_Type for details on them.

References elm_obj_entry_line_wrap_get().

## elm_entry_cursor_pos_set()

void elm_entry_cursor_pos_set | ( | Elm_Entry * | obj,
|  | int | pos )

Sets the cursor position in the entry to the given value.

The value in `pos` is the index of the character position within the contents of the string as returned by elm_entry_cursor_pos_get.

Parameters

  [in] | obj | The object.
  [in] | pos | The position of the cursor.

References elm_obj_entry_cursor_pos_set().

## elm_entry_cursor_pos_get()

int elm_entry_cursor_pos_get | ( | const Elm_Entry * | obj | ) |

Get the current position of the cursor in the entry.

Parameters

  [in] | obj | The object.

Returns
  The position of the cursor.

References elm_obj_entry_cursor_pos_get().

## elm_entry_icon_visible_set()

void elm_entry_icon_visible_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | setting )

Sets the visibility of the left-side widget of the entry, set by elm_object_part_content_set.

Parameters

  [in] | obj | The object.
  [in] | setting | `true` if the object should be displayed, `false` if not.

References elm_obj_entry_icon_visible_set().

## elm_entry_select_region_set()

void elm_entry_select_region_set | ( | Elm_Entry * | obj,
|  | int | start,
|  | int | end )

This selects a region of text within the entry.

Parameters

  [in] | obj | The object.
  [in] | start | The starting position.
  [in] | end | The end position.

Since
  1.9

References elm_obj_entry_select_region_set().

## elm_entry_select_region_get()

void elm_entry_select_region_get | ( | const Elm_Entry * | obj,
|  | int * | start,
|  | int * | end )

Get the current position of the selection cursors in the entry.

Parameters

  [in] | obj | The object.
  [out] | start | The starting position.
  [out] | end | The end position.

Since
  1.18

References elm_obj_entry_select_region_get().

## elm_entry_input_panel_return_key_autoenabled_set()

void elm_entry_input_panel_return_key_autoenabled_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | enabled )

Set whether the return key on the input panel is disabled automatically when entry has no text.

If `enabled` is `true`, The return key on input panel is disabled when the entry has no text. The return key on the input panel is automatically enabled when the entry has text. The default value is `false`.

Parameters

  [in] | obj | The object.
  [in] | enabled | If `enabled` is `true`, the return key is automatically disabled when the entry has no text.

References elm_obj_entry_input_panel_return_key_autoenabled_set().

## elm_entry_end_visible_set()

void elm_entry_end_visible_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | setting )

Sets the visibility of the end widget of the entry, set by elm_object_part_content_set(ent, "end", content).

Parameters

  [in] | obj | The object.
  [in] | setting | `true` if the object should be displayed, false if not.

References elm_obj_entry_end_visible_set().

## elm_entry_textblock_get()

Efl_Canvas_Object * elm_entry_textblock_get | ( | const Elm_Entry * | obj | ) |

Returns the actual textblock object of the entry.

This function exposes the internal textblock object that actually contains and draws the text. This should be used for low-level manipulations that are otherwise not possible.

Changing the textblock directly from here will not notify edje/elm to recalculate the textblock size automatically, so any modifications done to the textblock returned by this function should be followed by a call to elm_entry_calc_force.

The return value is marked as const as an additional warning. One should not use the returned object with any of the generic evas functions (geometry_get/resize/move and etc), but only with the textblock functions; The former will either not work at all, or break the correct functionality.

IMPORTANT: Many functions may change (i.e delete and create a new one) the internal textblock object. Do NOT cache the returned object, and try not to mix calls on this object with regular elm_entry calls (which may change the internal textblock object). This applies to all cursors returned from textblock calls, and all the other derivative values.

Parameters

  [in] | obj | The object.

Returns
  Textblock object

References elm_obj_entry_textblock_get().

## elm_entry_cursor_geometry_get()

Eina_Bool elm_entry_cursor_geometry_get | ( | const Elm_Entry * | obj,
|  | int * | x,
|  | int * | y,
|  | int * | w,
|  | int * | h )

This function returns the geometry of the cursor.

It's useful if you want to draw something on the cursor (or where it is), or for example in the case of scrolled entry where you want to show the cursor.

Parameters

  [in] | obj | The object.
  [out] | x | X coordinate
  [out] | y | Y coordinate
  [out] | w | Width
  [out] | h | Height

Returns
  `true` on success, `false` otherwise

References elm_obj_entry_textblock_cursor_geometry_get().

## elm_entry_imf_context_get()

void * elm_entry_imf_context_get | ( | const Elm_Entry * | obj | ) |

Returns the input method context of the entry.

This function exposes the internal input method context.

IMPORTANT: Many functions may change (i.e delete and create a new one) the internal input method context. Do NOT cache the returned object.

Parameters

  [in] | obj | The object.

Returns
  Input method context

References elm_obj_entry_imf_context_get().

## elm_entry_cursor_is_format_get()

Eina_Bool elm_entry_cursor_is_format_get | ( | const Elm_Entry * | obj | ) |

Get whether a format node exists at the current cursor position.

A format node is anything that defines how the text is rendered. It can be a visible format node, such as a line break or a paragraph separator, or an invisible one, such as bold begin or end tag. This function returns whether any format node exists at the current cursor position.

Parameters

  [in] | obj | The object.

Returns
  `true` if format node exists, `false` otherwise

References elm_obj_entry_cursor_is_format_get().

## elm_entry_cursor_content_get()

char * elm_entry_cursor_content_get | ( | const Elm_Entry * | obj | ) |

Get the character pointed by the cursor at its current position.

This function returns a string with the utf8 character stored at the current cursor position. Only the text is returned, any format that may exist will not be part of the return value. You must free the string when done with free.

Parameters

  [in] | obj | The object.

Returns
  Character

References elm_obj_entry_textblock_cursor_content_get().

## elm_entry_selection_get()

const char * elm_entry_selection_get | ( | const Elm_Entry * | obj | ) |

Get any selected text within the entry.

If there's any selected text in the entry, this function returns it as a string in markup format. `null` is returned if no selection exists or if an error occurred.

The returned value points to an internal string and should not be freed or modified in any way. If the `entry` object is deleted or its contents are changed, the returned pointer should be considered invalid.

Parameters

  [in] | obj | The object.

Returns
  Selected string

References elm_obj_entry_selection_get().

## elm_entry_cursor_is_visible_format_get()

Eina_Bool elm_entry_cursor_is_visible_format_get | ( | const Elm_Entry * | obj | ) |

Get if the current cursor position holds a visible format node.

Parameters

  [in] | obj | The object.

Returns
  `true` if position has a visible format, `false` otherwise

References elm_obj_entry_cursor_is_visible_format_get().

## elm_entry_select_allow_set()

void elm_entry_select_allow_set | ( | Elm_Entry * | obj,
|  | Eina_Bool | allow )

Allow selection in the entry.

Parameters

  [in] | obj | The object.
  [in] | allow | If `allow` is true, the text selection is allowed.

Since
  1.18

References elm_obj_entry_select_allow_set().

## elm_entry_select_allow_get()

Eina_Bool elm_entry_select_allow_get | ( | const Elm_Entry * | obj | ) |

Allow selection in the entry.

Parameters

  [in] | obj | The object.

Returns
  If `allow` is true, the text selection is allowed.

Since
  1.18

References elm_obj_entry_select_allow_get().

## elm_entry_cursor_prev()

Eina_Bool elm_entry_cursor_prev | ( | Elm_Entry * | obj | ) |

This moves the cursor one place to the left within the entry.

Parameters

  [in] | obj | The object.

Returns
  `true` on success, `false` otherwise

References elm_obj_entry_cursor_prev().

## elm_entry_text_style_user_pop()

void elm_entry_text_style_user_pop | ( | Elm_Entry * | obj | ) |

Remove the style in the top of user style stack.

Since
  1.7

References elm_obj_entry_text_style_user_pop().

## elm_entry_item_provider_prepend()

void elm_entry_item_provider_prepend | ( | Elm_Entry * | obj,
|  | Elm_Entry_Item_Provider_Cb | func,
|  | void * | data )

This prepends a custom item provider to the list for that entry.

This prepends the given callback.

Parameters

  [in] | obj | The object.
  [in] | func | The function called to provide the item object.
  [in] | data | The data passed to `func`.

References elm_obj_entry_item_provider_prepend().

## elm_entry_input_panel_show()

void elm_entry_input_panel_show | ( | Elm_Entry * | obj | ) |

Show the input panel (virtual keyboard) based on the input panel property of entry such as layout, autocapital types, and so on.

Note that input panel is shown or hidden automatically according to the focus state of entry widget. This API can be used in the case of manually controlling by using elm_entry_input_panel_enabled_set(en, `false`).

Parameters

  [in] | obj | The object.

References elm_obj_entry_input_panel_show().

## elm_entry_imf_context_reset()

void elm_entry_imf_context_reset | ( | Elm_Entry * | obj | ) |

Reset the input method context of the entry if needed.

This can be necessary in the case where modifying the buffer would confuse on-going input method behavior. This will typically cause the Input Method Context to clear the preedit state.

Parameters

  [in] | obj | The object.

References elm_obj_entry_imf_context_reset().

## elm_entry_anchor_hover_end()

void elm_entry_anchor_hover_end | ( | Elm_Entry * | obj | ) |

Ends the hover popup in the entry.

When an anchor is clicked, the entry widget will create a hover object to use as a popup with user provided content. This function terminates this popup, returning the entry to its normal state.

Parameters

  [in] | obj | The object.

References elm_obj_entry_anchor_hover_end().

## elm_entry_cursor_down()

Eina_Bool elm_entry_cursor_down | ( | Elm_Entry * | obj | ) |

This moves the cursor one line down within the entry.

Parameters

  [in] | obj | The object.

Returns
  `true` on success, `false` otherwise

References elm_obj_entry_cursor_down().

## elm_entry_text_style_user_push()

void elm_entry_text_style_user_push | ( | Elm_Entry * | obj,
|  | const char * | style )

Push the style to the top of user style stack.

If there is styles in the user style stack, the properties in the top style of user style stack will replace the properties in current theme. The input style is specified in format tag='property=value' (i.e. DEFAULT='font=Sans font_size=60'hilight=' + font_weight=Bold').

Parameters

  [in] | obj | The object.
  [in] | style | The style user to push.

Since
  1.7

References elm_obj_entry_text_style_user_push().

## elm_entry_item_provider_remove()

void elm_entry_item_provider_remove | ( | Elm_Entry * | obj,
|  | Elm_Entry_Item_Provider_Cb | func,
|  | void * | data )

This removes a custom item provider to the list for that entry.

This removes the given callback. See elm_entry_item_provider_append for more information

Parameters

  [in] | obj | The object.
  [in] | func | The function called to provide the item object.
  [in] | data | The data passed to `func`.

References elm_obj_entry_item_provider_remove().

## elm_entry_text_style_user_peek()

const char * elm_entry_text_style_user_peek | ( | const Elm_Entry * | obj | ) |

Get the style on the top of user style stack.

See also elm_entry_text_style_user_push.

Parameters

  [in] | obj | The object.

Returns
  Style

Since
  1.7

References elm_obj_entry_text_style_user_peek().

## elm_entry_context_menu_clear()

void elm_entry_context_menu_clear | ( | Elm_Entry * | obj | ) |

This clears and frees the items in a entry's contextual (longpress) menu.

See also elm_entry_context_menu_item_add.

Parameters

  [in] | obj | The object.

References elm_obj_entry_context_menu_clear().

## elm_entry_cursor_up()

Eina_Bool elm_entry_cursor_up | ( | Elm_Entry * | obj | ) |

This moves the cursor one line up within the entry.

Parameters

  [in] | obj | The object.

Returns
  `true` on success, `false` otherwise

References elm_obj_entry_cursor_up().

## elm_entry_entry_insert()

void elm_entry_entry_insert | ( | Elm_Entry * | obj,
|  | const char * | entry )

Inserts the given text into the entry at the current cursor position.

This inserts text at the cursor position as if it was typed by the user (note that this also allows markup which a user can't just "type" as it would be converted to escaped text, so this call can be used to insert things like emoticon items or bold push/pop tags, other font and color change tags etc.)

If any selection exists, it will be replaced by the inserted text.

The inserted text is subject to any filters set for the widget.

See also elm_entry_markup_filter_append.

Parameters

  [in] | obj | The object.
  [in] | entry | The text to insert.

References elm_obj_entry_insert().

## elm_entry_input_panel_imdata_set()

void elm_entry_input_panel_imdata_set | ( | Elm_Entry * | obj,
|  | const void * | data,
|  | int | len )

Set the input panel-specific data to deliver to the input panel.

This API is used by applications to deliver specific data to the input panel. The data format MUST be negotiated by both application and the input panel. The size and format of data are defined by the input panel.

Parameters

  [in] | obj | The object.
  [in] | data | The specific data to be set to the input panel.
  [in] | len | The length of data, in bytes, to send to the input panel.

References elm_obj_entry_input_panel_imdata_set().

## elm_entry_input_panel_imdata_get()

void elm_entry_input_panel_imdata_get | ( | const Elm_Entry * | obj,
|  | void * | data,
|  | int * | len )

Get the specific data of the current input panel.

Parameters

  [in] | obj | The object.
  [out] | data | The specific data to be got from the input panel.
  [out] | len | The length of data.

References elm_obj_entry_input_panel_imdata_get().

## elm_entry_cursor_next()

Eina_Bool elm_entry_cursor_next | ( | Elm_Entry * | obj | ) |

This moves the cursor one place to the right within the entry.

Parameters

  [in] | obj | The object.

Returns
  `true` on success, `false` otherwise

References elm_obj_entry_cursor_next().

## elm_entry_input_panel_hide()

void elm_entry_input_panel_hide | ( | Elm_Entry * | obj | ) |

Hide the input panel (virtual keyboard).

Note that input panel is shown or hidden automatically according to the focus state of entry widget. This API can be used in the case of manually controlling by using elm_entry_input_panel_enabled_set(en, `false`)

Parameters

  [in] | obj | The object.

References elm_obj_entry_input_panel_hide().

## elm_entry_is_empty()

Eina_Bool elm_entry_is_empty | ( | const Elm_Entry * | obj | ) |

Get whether the entry is empty.

Empty means no text at all. If there are any markup tags, like an item tag for which no provider finds anything, and no text is displayed, this function still returns `false`.

Parameters

  [in] | obj | The object.

Returns
  `true` if empty, `false` otherwise

References elm_obj_entry_is_empty().

## elm_entry_markup_filter_remove()

void elm_entry_markup_filter_remove | ( | Elm_Entry * | obj,
|  | Elm_Entry_Filter_Cb | func,
|  | void * | data )

Remove a markup filter from the list.

Removes the given callback from the filter list. See elm_entry_markup_filter_append for more information.

Parameters

  [in] | obj | The object.
  [in] | func | The filter function to remove.
  [in] | data | The user data passed when adding the function.

References elm_obj_entry_markup_filter_remove().

## elm_entry_item_provider_append()

void elm_entry_item_provider_append | ( | Elm_Entry * | obj,
|  | Elm_Entry_Item_Provider_Cb | func,
|  | void * | data )

This appends a custom item provider to the list for that entry.

This appends the given callback. The list is walked from beginning to end with each function called given the item href string in the text. If the function returns an object handle other than `null` (it should create an object to do this), then this object is used to replace that item. If not the next provider is called until one provides an item object, or the default provider in entry does.

See also Items.

Parameters

  [in] | obj | The object.
  [in] | func | The function called to provide the item object.
  [in] | data | The data passed to `func`.

References elm_obj_entry_item_provider_append().

## elm_entry_markup_filter_append()

void elm_entry_markup_filter_append | ( | Elm_Entry * | obj,
|  | Elm_Entry_Filter_Cb | func,
|  | void * | data )

Append a markup filter function for text inserted in the entry.

Append the given callback to the list. This functions will be called whenever any text is inserted into the entry, with the text to be inserted as a parameter. The type of given text is always markup. The callback function is free to alter the text in any way it wants, but it must remember to free the given pointer and update it. If the new text is to be discarded, the function can free it and set its text parameter to `null`. This will also prevent any following filters from being called.

Parameters

  [in] | obj | The object.
  [in] | func | The function to use as text filter.
  [in] | data | User data to pass to `func`.

References elm_obj_entry_markup_filter_append().

## elm_entry_entry_append()

void elm_entry_entry_append | ( | Elm_Entry * | obj,
|  | const char * | str )

Appends `str` to the text of the entry.

Adds the text in `str` to the end of any text already present in the widget.

The appended text is subject to any filters set for the widget.

See also elm_entry_markup_filter_append.

Parameters

  [in] | obj | The object.
  [in] | str | The text to be appended.

References elm_obj_entry_append().

## elm_entry_context_menu_item_add()

void elm_entry_context_menu_item_add | ( | Elm_Entry * | obj,
|  | const char * | label,
|  | const char * | icon_file,
|  | Elm_Icon_Type | icon_type,
|  | Evas_Smart_Cb | func,
|  | const void * | data )

This adds an item to the entry's contextual menu.

A longpress on an entry will make the contextual menu show up, if this hasn't been disabled with elm_entry_context_menu_disabled_set. By default, this menu provides a few options like enabling selection mode, which is useful on embedded devices that need to be explicit about it, and when a selection exists it also shows the copy and cut actions.

With this function, developers can add other options to this menu to perform any action they deem necessary.

Parameters

  [in] | obj | The object.
  [in] | label | The item's text label.
  [in] | icon_file | The item's icon file.
  [in] | icon_type | The item's icon type.
  [in] | func | The callback to execute when the item is clicked.
  [in] | data | The data to associate with the item for related functions.

References elm_obj_entry_context_menu_item_add().

## elm_entry_markup_filter_prepend()

void elm_entry_markup_filter_prepend | ( | Elm_Entry * | obj,
|  | Elm_Entry_Filter_Cb | func,
|  | void * | data )

Prepend a markup filter function for text inserted in the entry.

Prepend the given callback to the list.

Parameters

  [in] | obj | The object.
  [in] | func | The function to use as text filter.
  [in] | data | User data to pass to `func`.

References elm_obj_entry_markup_filter_prepend().

## elm_entry_prediction_hint_set()

void elm_entry_prediction_hint_set | ( | Elm_Entry * | obj,
|  | const char * | prediction_hint )

Sets the prediction hint to use an intelligent reply suggestion service.

Parameters

  [in] | obj | The object.
  [in] | prediction_hint | The prediction hint text.

Since
  1.20

References elm_obj_entry_prediction_hint_set().

## elm_entry_prediction_hint_hash_set()

Eina_Bool elm_entry_prediction_hint_hash_set | ( | Elm_Entry * | obj,
|  | const char * | key,
|  | const char * | value )

Sets the prediction hint data at the specified key.

Parameters

  [in] | obj | The object.
  [in] | key | The key of the prediction hint.
  [in] | value | The data to replace.

Returns
  `true` on success, `false` otherwise

Since
  1.21

References elm_obj_entry_prediction_hint_hash_set().

## elm_entry_prediction_hint_hash_del()

Eina_Bool elm_entry_prediction_hint_hash_del | ( | Elm_Entry * | obj,
|  | const char * | key )

Removes the prediction hint data identified by a key.

Parameters

  [in] | obj | The object.
  [in] | key | The key of the prediction hint.

Returns
  `true` on success, `false` otherwise

Since
  1.21

References elm_obj_entry_prediction_hint_hash_del().

## elm_entry_add()

Evas_Object * elm_entry_add | ( | Evas_Object * | parent | ) |

This adds an entry to `parent` object.

By default, entries are:

- not scrolled
- multi-line
- word wrapped
- autosave is enabled

Parameters

  parent | The parent object

Returns
  The new object or NULL if it cannot be created

References EINA_SAFETY_ON_NULL_RETURN_VAL.

## elm_entry_entry_set()

void elm_entry_entry_set | ( | Evas_Object * | obj,
|  | const char * | entry )

This sets the text displayed within the entry to `entry`.

Parameters

  obj | The entry object
  entry | The text to be displayed

Note
  Using this function bypasses text filters

## elm_entry_entry_get()

const char * elm_entry_entry_get | ( | const Evas_Object * | obj | ) |

This returns the text currently shown in object `entry`.

See also elm_entry_entry_set().

Parameters

  obj | The entry object

Returns
  The currently displayed text or NULL on failure

## elm_entry_file_set()

Eina_Bool elm_entry_file_set | ( | Evas_Object * | obj,
|  | const char * | file,
|  | Elm_Text_Format | format )

This sets the file (and implicitly loads it) for the text to display and then edit.

All changes are written back to the file after a short delay if the entry object is set to autosave (which is the default).

If the entry had any other file set previously, any changes made to it will be saved if the autosave feature is enabled, otherwise, the file will be silently discarded and any non-saved changes will be lost.

Returns
  `EINA_TRUE` on success, `EINA_FALSE` otherwise

Parameters

  [in] | obj | The entry object
  [in] | file | The path to the file to load and save
  [in] | format | The file format

References ecore_timer_del(), EINA_FALSE, EINA_TRUE, and elm_obj_entry_file_text_format_set().

## elm_entry_file_get()

void elm_entry_file_get | ( | const Evas_Object * | obj,
|  | const char ** | file,
|  | Elm_Text_Format * | format )

Get the file being edited by the entry.

This function can be used to retrieve any file set on the entry for edition, along with the format used to load and save it.

Parameters

  [in] | obj | The entry object
  [out] | file | The path to the file to load and save
  [out] | format | The file format

## elm_entry_calc_force()

void elm_entry_calc_force | ( | Evas_Object * | obj | ) |

Forces calculation of the entry size and text layouting.

This should be used after modifying the textblock object directly. See elm_entry_textblock_get for more information.

Parameters

  [in] | obj | The object.